/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Comment;
import org.apache.poi.ss.usermodel.DateUtil;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;

/**
 * Excelt@CǂݍރNX
 * .xls 2003  .xlsx 2007 ̗ǂݍ
 * @author Yuu
 * @since 2011-08
 */
public class ExcelSearch {

	/* Excelt@C */
	Workbook wb = null;

	/* V[g */
	int sheetLastCount = 0;
	/* V[g̍ŏIs */
	int rowLastCount = 0;
	/* Z̐ */
	int cellLastCount = 0;

	/* V[g */
	Sheet sheet;
	/* s */
	Row row;
	/* Z */
	Cell cell;

	/* Rg */
	Comment com;

	InputStream inp;

	/** Excelt@C̕GREPŃqbgl(̃Z). */
	ArrayList<String[]> excelList = new ArrayList<String[]>();

	/** t@CpXAt@CAZ̈ʒuA@ۑz. */
	//String cellKekkaStr[] = new String[5];

	/** ʕۑf[^NX. */
	DataSearch dataSearch = new DataSearch();

	/**
	 * Excelt@Cɂ镶擾GREP܂ł
	 * GREPŃqbgZ̒lArrayListŕԂ.
	 *
	 * @param excelFile   Excelt@C
	 * @param grepSearch  GrepSearchNX
	 * @return            GREPŃqbgZ̒lArrayListŕԂ
	 * @throws InvalidFormatException
	 * @throws IOException
	 */
	public ArrayList<String[]> getExcelGrepString(File excelFile,GrepSearch grepSearch,GrepTaskWorker gtw) throws InvalidFormatException, IOException {

		ArrayList<String[]> arrTempList = new ArrayList<String[]>();

		excelList = new ArrayList<String[]>();

		/* t@C̍Ōオ(gq)Excelt@C`FbN */
		if ( !excelFile.getPath().endsWith(".xls") && !excelFile.getPath().endsWith(".xlsx")) {
			return excelList;
		}

		inp = new FileInputStream(excelFile);

		wb = WorkbookFactory.create(inp);

		/* V[g𓾂 */
		sheetLastCount = wb.getNumberOfSheets();

		/* V[g̐[v */
		for (int s = 0; s <= sheetLastCount -1; s++) {

			/* LZ̏ꍇ */
			if (gtw.isCancelled() == true) {
				return excelList;
			}

			/* ͂߂̃V[g */
			sheet = wb.getSheetAt(s);

			/*** V[gɂRgׂĎ擾
			 * Rǧ                   ***/
			arrTempList = getSheetComents(excelFile,sheet);
			/* GREPăqbgsԂ */
			/* GrepSearchNXɃ\bh쐬AArraylist當擾
			 * GrepăqbgsԂB */
			grepSearch.getListGrep(arrTempList,excelList,grepSearch);
			arrTempList = null;
			/*** RǧI ***/

			/* V[g̍ŏIs𓾂 */
			rowLastCount = sheet.getLastRowNum();

			/* s̐[v */
			for (int r = 0; r <= rowLastCount; r++) {

				/* LZ̏ꍇ */
				if (gtw.isCancelled() == true) {
					return excelList;
				}

				row = sheet.getRow(r);

				if (row != null) {

					/* 1sɂZ̒l擾(ׂ̕) */
					arrTempList = getRowString(excelFile,row);

					/* GREPăqbgsԂ */
					/* GrepSearchNXɃ\bh쐬AArraylist當擾
					 * GrepăqbgsԂB
					 * excelListɌʂ*/
					grepSearch.getListGrep(arrTempList,excelList,grepSearch);

					arrTempList = null;
				}
			}
		}

		return excelList;

	}

	/**
	 * ExcelV[g1sƂɂZ̒lׂArrayListŕԂ
	 * ArrayList̓eString^z t@CpXAt@CAsԍ(V[gAsA)Ae.
	 *
	 * @param excelFile  Excelt@C
	 * @param rw         s
	 * @return ArrayList̓eString^z t@CpXAt@CAsԍ(V[gAsA)Ae
	 */
	public ArrayList<String[]> getRowString(File excelFile,Row rw) {
		/* V[g̕ */
		ArrayList<String[]> excelRowList = new ArrayList<String[]>();

		String cellPosi;
		String sheetName;

		/* Z̐𓾂 */
		cellLastCount = rw.getLastCellNum();

		/* V[g̖O𓾂 */
		sheetName = rw.getSheet().getSheetName();

		/* Z̐[v */
		for (int c = 0; c <= cellLastCount; c++) {
			/* Z擾 */
			cell = rw.getCell(c);

			if (cell != null) {
				/* Z̒ľ^ */
				int cellType = cell.getCellType();

				/* ZɂRg擾 */
				//com = cell.getCellComment();

				/* Z̒ľ^ɂď𕪂 */
				switch (cellType) {
				case Cell.CELL_TYPE_BOOLEAN:

					break;
				case Cell.CELL_TYPE_NUMERIC:
					/* t^Cv͐l^ƂĔ肳邽߂xtl肷 */
					if(DateUtil.isCellDateFormatted(cell)) {
						/* t^Cv */
						Date date = cell.getDateCellValue();

						/* s+ */
						cellPosi = String.valueOf("V[g: " +sheetName + " : " + (row.getRowNum()+1) + "s" + "," + String.valueOf(c+1) + "");

						/*  */
						String cellStr = date.toString();

						/* ʂz */
						//cellKekkaStr = getNaiyouStr(excelFile,cellPosi,cellStr);

						/*  */
						//excelRowList.add(cellKekkaStr);
						excelRowList.add(dataSearch.setGrepNaiyouStr(excelFile, cellPosi, cellStr, ""));

					}else{

						/* s+ */
						cellPosi = String.valueOf("V[g: " +sheetName + " : " + (row.getRowNum()+1) + "s" + "," + String.valueOf(c+1) + "");
						/*  */
						String cellStr = Double.toString(cell.getNumericCellValue());

						/* ʂz */
						//cellKekkaStr = getNaiyouStr(excelFile,cellPosi,cellStr);

						/*  */
						//excelRowList.add(cellKekkaStr);
						excelRowList.add(dataSearch.setGrepNaiyouStr(excelFile, cellPosi, cellStr, ""));

					}
					break;
				case Cell.CELL_TYPE_STRING:
					/* String^̏ꍇ */

					/* s+ */
					cellPosi = String.valueOf("V[g: " +sheetName + " : " + (row.getRowNum()+1) + "s" + "," + String.valueOf(c+1) + "");

					/*  */
					String cellStr = cell.toString();

					/* ʂz */
					//cellKekkaStr = getNaiyouStr(excelFile,cellPosi,cellStr);

					/*  */
					//excelRowList.add(cellKekkaStr);
					excelRowList.add(dataSearch.setGrepNaiyouStr(excelFile, cellPosi, cellStr, ""));

					break;
				case Cell.CELL_TYPE_BLANK:
				case Cell.CELL_TYPE_ERROR:
				case Cell.CELL_TYPE_FORMULA:
				}

			}

		}

		return excelRowList;

	}


	/**
	 * V[gɂRgׂĕԂ
	 * Z̗256񒲂ׂ.
	 * @param excelFile   GNZt@C
	 * @param st          V[g
	 * @return            V[gɂRg̕ZԍƂƂ
	 */
	public ArrayList<String[]> getSheetComents(File excelFile,Sheet st) {

		String sheetName;

		/* V[g̖O𓾂 */
		sheetName = st.getSheetName();

		/* Z̈ʒuԍ */
		String cellPosi;

		/* V[g̕ */
		ArrayList<String[]> excelRowList = new ArrayList<String[]>();

		/* V[g̍ŏIs𓾂 */
		rowLastCount = st.getLastRowNum();

		/* s̐[v */
		for (int r = 0; r <= rowLastCount; r++) {
			row = st.getRow(r);

			if (row != null) {
				/* Z̐𓾂 */
				cellLastCount = row.getLastCellNum();

				/* Rg̍siZɒl͓ĂȂj̏ꍇ row.getLastCellNum() 
				 * l-1Ȃ̂łƂ肠256̓RgȂׂ
				 * ŝ͉Rĝ݂łsheet.getLastRowNum()Ŏ*/
				for (int cm = 0; cm <= 256; cm++) {
					com = st.getCellComment(r, cm);
					if ( com != null ) {
						/* Z̃Rg\ */

						/* s+ */
						cellPosi = String.valueOf("V[g: " +sheetName + " : " + (row.getRowNum()+1) + "s" + "," + String.valueOf(cm+1) + "");

						/* Rg */
						String cellStr = com.getString().toString();

						/* ʂz */
						//cellKekkaStr = getNaiyouStr(excelFile,cellPosi,cellStr);

						/*  */
						//excelRowList.add(cellKekkaStr);
						excelRowList.add(dataSearch.setGrepNaiyouStr(excelFile, cellPosi, cellStr, ""));

					}
				}
			}
		}

		return excelRowList;
	}

	//	/**
	//	 * e@t@CpXAt@CAZ̈ʒuA@ۑz.
	//	 * @param wordFile   t@C
	//	 * @param posi@@@ sԍ
	//	 * @param naiyouStr  e
	//	 * @return  Stringz
	//	 */
	//	public String[] getNaiyouStr(File wordFile,String posi,String naiyouStr) {
	//
	//		String kekkaStr[] = new String[5];
	//		/* t@C̃pX */
	//		kekkaStr[0] = wordFile.getAbsolutePath();
	//		/* t@C̖O */
	//		kekkaStr[1] = wordFile.getName();
	//		/* s+ */
	//		kekkaStr[2] = posi;
	//		/*  */
	//		kekkaStr[3] = naiyouStr;
	//
	//		/*  */
	//		return kekkaStr;
	//
	//	}

}
