/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingWorker;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


/**
 * tH_At@C^u ʃNX.
 * @author Yuu
 * @version 3.0
 * @since 2011
 */
public class FileSearchTab extends JPanel {

	/** t@C. */
	JLabel fileName;
	/** pX. */
	JLabel pathName;

	/** . */
	MyJComboBox fileCombB;
	/** pXAꏊ@. */
	MyJComboBox pathCombB;

	/** {^. */
	JButton searchBtn = new JButton(" @ @ ");;
	/** LZ{^. */
	JButton cancelBtn = new JButton("LZ");

	/** 啶ʃtO */
	static JCheckBox mojiCheck = new JCheckBox("啶ʂ");	

	/** io[\ */
	JProgressBar progBar = new JProgressBar();

	/** ʃe[u. */
	ITableResult resultTable;
	JScrollPane scrollTable;

	/** ʃeLXgzu^u. */
	MyJTabbedPaneS myTabbedPane;

	/** ̓tB[hzupl. */
	JPanel searchPane;

	/** CAEg. */
	GridBagLayout layout;
	/** gridx ͉@gridy͏c. */
	GridBagConstraints gbclayout;

	/** ^u̖O. */
	private String tabName = "VK";

	/** GREPXbh. */
	SwingWorker taskFSWorker;

	SearchApp seaApp;	

	public FileSearchTab(SearchApp frame) {

		seaApp = frame;
		searchPane = new JPanel();

		fileName = new JLabel(" 镶 ");
		pathName = new JLabel(" pXAꏊ  ");

		/** ʃe[u. */
		resultTable = new TableResultFile();
		resultTable.setAutoResizeMode( JTable.AUTO_RESIZE_OFF );   //e[ũTCYύXɃe[u̎TCYύX[hݒ肵܂B(̏JTablẻXN[\)
		/* GrepTabNX̃IuWFNg𓾂邽߂ */
		resultTable.setGrepTab(frame);
		
		/* JProgressBar */
		progBar.setStringPainted(true);
		progBar.setString("");
		progBar.setValue(0);
		//progBar.setVisible(false);

		scrollTable = new JScrollPane();
		scrollTable.getViewport().setView((Component) resultTable);
		scrollTable.setPreferredSize(new Dimension(250,100));

		/** ʃeLXgzu^u. */
		myTabbedPane = new MyJTabbedPaneS();
		myTabbedPane.add(tabName,scrollTable);		

		fileCombB = new MyJComboBox(new String[]{""});
		fileCombB.setEditable(true);

		pathCombB = new MyJComboBox(new String[]{""});
		pathCombB.setEditable(true);

		layout = new GridBagLayout();
		gbclayout = new GridBagConstraints();

		this.setLayout(new BorderLayout());
		/** ̓tB[hzupl̃CAEg */
		searchPane.setLayout(layout);

		/**                                    *
		 * JLabel̔zuʒu@(0,0)   *
		 *                                      */
		gbclayout.gridx = 0;
		gbclayout.gridy = 0;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		//gbclayout.weightx = 1.0d;
		//gbclayout.weighty = 1.0d;

		gbclayout.insets = new Insets(10,30,3,4);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.CENTER;
		//gbclayout.anchor = GridBagConstraints.NORTHWEST;
		layout.setConstraints(fileName, gbclayout);

		/**                                                                                    *
		 *  tH_At@C JComboBox̔zuʒu@(1,0)  *
		 *                                                                                      */
		gbclayout.gridx = 1;
		gbclayout.gridy = 0;
		/** tH_At@C JComboBox̔zu */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 3;

		//gbclayout.weightx = 1.0d;
		//gbclayout.weighty = 1.0d;

		gbclayout.insets = new Insets(10,4,3,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(fileCombB, gbclayout);

		/**                                           *
		 *  JLabel̔zuʒu@(0,1)         *
		 *                                             */
		gbclayout.gridx = 0;
		gbclayout.gridy = 1;

		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.weightx = 0;
		gbclayout.weighty = 0;

		gbclayout.insets = new Insets(4,30,2,4);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(pathName, gbclayout);

		/**                                                                                    *
		 *  pXAꏊ@ pathCombB̔zuʒu@(1,1)                 *
		 *                                                                                      */
		gbclayout.gridx = 1;
		gbclayout.gridy =1;
		/** pXAꏊ@ JComboBox̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 3;

		//gbclayout.weightx = 1.0d;
		//gbclayout.weighty = 1.0d;

		gbclayout.insets = new Insets(4,4,2,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(pathCombB, gbclayout);	

		/**                                                                         *
		 *  啶`FbNzu                                     *
		 *                                                                           */
		gbclayout.gridx = 0;
		gbclayout.gridy = 2;
		/** 啶`FbN{bNXzuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		//gbclayout.weightx = 0;		
		//gbclayout.weightx = 0.2d;
		//gbclayout.weighty = 1.0d;

		gbclayout.insets = new Insets(10,30,10,5);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(mojiCheck, gbclayout);

		/**                                                                         *
		 *  {^zu                                                    *
		 *                                                                           */
		gbclayout.gridx = 2;
		gbclayout.gridy = 3;
		/** {^̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.weightx = 1;		
		//gbclayout.weightx = 0.2d;
		//gbclayout.weighty = 1;

		gbclayout.insets = new Insets(20,5,10,5);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.EAST;
		layout.setConstraints(searchBtn, gbclayout);

		/**                                                                         *
		 *  LZ{^zu                                           *
		 *                                                                           */	
		gbclayout.gridx = 3;
		gbclayout.gridy = 3;
		/** {^̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		//gbclayout.weightx = 1;
		gbclayout.weightx = 0;
		//gbclayout.weighty = 1;

		gbclayout.insets = new Insets(20,5,10,20);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(cancelBtn, gbclayout);


		/**                                               *
		 *  io[zu                             *
		 *                                                 */
		gbclayout.gridx = 0;
		gbclayout.gridy = 4;
		/** io[̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth =4;

		//gbclayout.weightx = 1.0d;

		gbclayout.insets = new Insets(4,10,8,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(progBar, gbclayout);


		searchPane.add(fileName);
		searchPane.add(fileCombB);

		searchPane.add(pathName);
		searchPane.add(pathCombB);	
		searchPane.add(mojiCheck);
		searchPane.add(searchBtn);
		searchPane.add(cancelBtn);
		searchPane.add(progBar);

		this.add(searchPane,BorderLayout.NORTH);
		this.add(myTabbedPane,BorderLayout.CENTER);

		/** {^Cxg. */
		searchBtn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				//threadStart();
				/*  */
				taskFSWorker = new FileSearchTaskWorker(seaApp,FileSearchTab.this);
				taskFSWorker.execute();
			}   
		});

		/** LZ{^Cxg. */
		cancelBtn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* Kx[WRNVs */
				 Runtime.getRuntime().gc();
				seaApp.repaint();
				 /* [XV */
				SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
				SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);
				
				/*@t@CI */
				if(taskFSWorker!=null && !taskFSWorker.isDone()) {
					taskFSWorker.cancel(true);
				}
				taskFSWorker = null;
				//resultTable = null;	

			}  	 
		});

		/**
		 * tH[JX𓾂ĂTab.
		 * 
		 * */	
		myTabbedPane.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				/* I\ĂTabJTextPasne𓾂 */
				scrollTable =  (JScrollPane) myTabbedPane.getSelectedComponent();
				ITableResult resultTable = (ITableResult)scrollTable.getViewport().getView();

				/* Xe[^Xo[Ɍʂ\ */
				SearchApp.taskbarLbl.setText(resultTable.getProgresBarStr() + "@@");
			}

		});	  

	}

	/**
	 * ʐݒ  uv{^gpsAio[\Ae[ȕ.
	 */
	public  void threadStart() {
		/* {^gpsɐݒ */
		searchBtn.setEnabled(false);

		/* io[ */
		progBar.setIndeterminate(true);
		progBar.setVisible(true);

		/** ͂ꂽǉݒ */	
		//seaApp.setComboBoxStr(fileCombB);
		fileCombB.setComboBoxStr();
		/** ͂ꂽt@CpXǉݒ*/	
		//seaApp.setComboBoxStr(pathCombB);
		pathCombB.setComboBoxStr();
		
		/* Vʕ\^u쐬 */
		seaApp.creatTab(fileCombB.getSelectedItem().toString(), resultTable, scrollTable, myTabbedPane,"");
	}

	/**
	 * Iʐݒ@uv{^gpsAio[~.
	 */
	public void threadEnd() {
		/* {^gp\ɐݒ */
		searchBtn.setEnabled(true);
		/* io[ */
		progBar.setIndeterminate(false);
		//progBar.setVisible(false);
	}

//		public static void main(String[] args) {
//			
//			JFrame myf = new JFrame();
//			FileSearchTab myF = new FileSearchTab();
//			
//			//myf.getContentPane().add(myF ,BorderLayout.NORTH);
//			myf.getContentPane().add(myF);
//			myf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//		    myf.setBounds(10, 10, 400, 500);
//		    myf.setTitle("^Cg");
//		    myf.setVisible(true);
//	
//			
//		}

}
