/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.File;
import java.util.ArrayList;
import java.util.regex.PatternSyntaxException;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;


/**
 * File tH_ ̌XbhŎs.
 * @author Yuu
 * @version 3.20
 */
public class FileSearchTaskWorker extends SwingWorker <String, String>  {

	/** FileNX. */
	private FileSearch fileSearch = new FileSearch();

	/** [U[͂. */
	private String fileSearchStr = "";

	/** [U[͂tH_ */
	private String folderStr = "";	

	/** LZꂽǂ. */
	public static boolean cancelbool = false;

	/** G[e\. */
	StringBuffer stbErr = new StringBuffer();

	/** t@C. */
	private long allFileCount = 0;

	/** qbg. */
	private long rowCount = 0;

	/** vOXo[\. */
	StringBuffer stbProg = new StringBuffer();

	/** ʕۑ. */
	private ArrayList<String[]> arrData;

	private SearchApp seaApp;

	private FileSearchTab fsTab;
	
	/** G[x(). */
	private String errMojiStr = "t@C͂ĂB";
	
	/** G[x(pXAꏊ). */
	private String errFolderStr = "pXAꏊ͂ĂB";

	public FileSearchTaskWorker(SearchApp frame,FileSearchTab fTab) {
		fsTab = fTab;
		seaApp = frame;	
	}


	/* ( Javadoc)
	 * @see javax.swing.SwingWorker#doInBackground()
	 * 	 Xbhs execute() Ŏs
	 * 
	 */
	@Override
	protected String doInBackground() throws Exception {
		// TODO ꂽ\bhEX^u

		cancelbool = false;

		fileSearchStr = fsTab.fileCombB.getSelectedItem().toString();

		folderStr =fsTab.pathCombB.getSelectedItem().toString();
		
		/* l͂̎G[_CAO\(񖢓͂̏ꍇ)*/
		if (fileSearchStr.equals("")) {
			SearchApp.showMessage(this.errMojiStr);
			/* Iʐݒ */
			//fileSearchStr.threadEnd();
			return null;
		}
		/* l͂̎G[_CAO\(pXAꏊ͂̏ꍇ) */
		if (folderStr.equals("")) {
			SearchApp.showMessage(errFolderStr);
			/* Iʐݒ */
			//fileSearchStr.threadEnd();
			return null;
		}
		
		/* Oʐݒ */
		fsTab.threadStart();

		/** ͂ꂽpXFileNX */
		File pathFile = new File(folderStr);

		try {	

			/* 镶𐳋K\ */
			fileSearch.compile(fileSearchStr,FileSearchTab.mojiCheck.isSelected());	    	

			/* tH_At@C */ 
			fileSearchRefx(pathFile);

		} catch (PatternSyntaxException x) {
			//System.err.println(x.getMessage());
			stbErr.append(" K\̃G[ : ɃGXP[vuvĂ" + SearchApp.crlf);
			/* Iʐݒ */
			fsTab.threadEnd();
		}  catch (Exception err) {
			stbErr.append(" G[ł " + SearchApp.crlf);	    	
			/* Iʐݒ */
			fsTab.threadEnd();
		} catch (NoClassDefFoundError nce) {
			/*OjarCuǂݍ܂ȂƂG[\AI */
			/* G[_CAO\p */
			stbErr.append("Ojart@Cǂݍ߂܂łANĂB : " + nce.toString() + SearchApp.crlf);
			/* Iʐݒ */
			fsTab.threadEnd();
		}

		return null;
	} 

	/* ( Javadoc)
	 * @see javax.swing.SwingWorker#done()
	 * 
	 * XbhIs.
	 * 
	 */
	protected void done() {
		fsTab.threadEnd();

		cancelbool = true;

		String pStr = getProgresStr();
		/* vOXo[ɕ\Ăʐe[uɕۑ */
		fsTab.resultTable.setProgressBarStr(pStr);
		/* ʉɕ\ */
		SearchApp.taskbarLbl.setText(pStr + "@@");

		/* vOXo[XV(I̕t) */
		fsTab.progBar.setString(SearchApp.END_STR + pStr);
		
		/* Kx[WRNVs */
		 Runtime.getRuntime().gc();		
		 /* [XV */
		SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
		SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);		

		/* G[Ε\ */
		if (stbErr.length() > 0) {
			SearchApp.showTextMessage(seaApp, stbErr, "I܂B G[̂e", JOptionPane.INFORMATION_MESSAGE);
		}
	}

	/**
	 * t@CċAIɂ.
	 * @param pathFile
	 * @throws Exception 
	 */
	public void fileSearchRefx(File pathFile) throws Exception {
		/* LZꂽȉsȂ */
		if( isCancelled() ) {
			return;
		}

		/* t@C̒Xg */
		File listFile[];

		/*  */
		fileSearch(pathFile);

		if (pathFile.isDirectory() == true) {
			/* tH_ȂċAIɌ */
			listFile = pathFile.listFiles();

			/* tH_̒g͌Ȃ */
			if ( listFile == null ) {
				return;
			}

			/* t@C̐ */
			for (int i = 0; i < listFile.length; i++) {
				/* LZꂽȉsȂ */
				if( isCancelled() ) {
					return;
				}
				/* ċAIɌ */
				fileSearchRefx(listFile[i]);				
			}		
		}
	}

	/**
	 * t@CČʂe[u֕\.
	 * @param file   t@C
	 * @throws Exception 
	 */
	public void fileSearch(File file) throws Exception {
		/* LZꂽȉsȂ */
		if( isCancelled() ) {
			return;
		}

		/* t@C */
		allFileCount += 1;
		/* vOXo[XV */
		fsTab.progBar.setString(getProgresStr(allFileCount,rowCount));

		/* t@C */
		arrData = fileSearch.search(file);

		/* \e[uɌʂǉ */		
		for (int i = 0; arrData.size() > i; i++) {
			/* ʂe[u֍sǉ  */
			fsTab.resultTable.addTableRow( arrData.get(i) );
		}

		/* qbg */
		rowCount += arrData.size();
		/* vOXo[XV */
		fsTab.progBar.setString(getProgresStr(allFileCount,rowCount));

		 /* [XV */
		SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
		SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);
		
		arrData = null;

	}

	/**
	 * vOXo[ɕ\镶쐬ĕԂ.
	 * @param allFileCount  t@C,tH_
	 * @param rowCount      qbgs
	 * @return              \镶Ԃ
	 */
	public String getProgresStr(long allFileCount,long rowCount) {

		stbProg.delete(0, stbProg.length());
		stbProg.append("@t@C,tH_ : ");
		stbProg.append(SearchApp.format.format(allFileCount));
		stbProg.append("       ");
		stbProg.append("@Yt@C,tH_ : ");
		stbProg.append(SearchApp.format.format(rowCount));

		return stbProg.toString();
	}

	public String getProgresStr() {
		return stbProg.toString();
	}	

}
