/*
 * @(#)Grep.java	1.3 01/12/13
 * Search a list of files for lines that match a given regular-expression
 * pattern.  Demonstrates NIO mapped byte buffers, charsets, and regular
 * expressions.
 *
 * Copyright 2001-2002 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 *
 * -Redistributions of source code must retain the above copyright
 * notice, this  list of conditions and the following disclaimer.
 *
 * -Redistribution in binary form must reproduct the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 *
 * Neither the name of Sun Microsystems, Inc. or the names of
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * This software is provided "AS IS," without a warranty of any
 * kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
 * EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY
 * DAMAGES OR LIABILITIES  SUFFERED BY LICENSEE AS A RESULT OF  OR
 * RELATING TO USE, MODIFICATION OR DISTRIBUTION OF THE SOFTWARE OR
 * ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE
 * FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT,
 * SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF
 * THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 * You acknowledge that Software is not designed, licensed or
 * intended for use in the design, construction, operation or
 * maintenance of any nuclear facility.
 */
/* LURLQl                                                                                                   */
/* http://java.sun.com/javase/ja/6/docs/ja/technotes/guides/io/example/index.html */
/*
/* Copyright (C) 2011  Yuu */

import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.nio.charset.*;
import java.util.ArrayList;
import java.util.regex.*;

import org.mozilla.universalchardet.UniversalDetector;

/**
 * @author Yuu
 * @version 12.00
 * @since 2010-11-30
 */
public class GrepSearch {

	private Charset charset;
	private CharsetDecoder decoder;

	/** Ώۃt@CPsɕ. */
	//private Pattern linePattern = Pattern.compile(".*\r?\n");
	//private Pattern linePattern = Pattern.compile(".*\r?\n|.*\\z");
	// \r ǉ
	private  Pattern linePattern = Pattern.compile(".*\r?\n|.*\r|.*\\z");
	//private  Pattern linePattern = Pattern.compile(".*\r?\n|.*\r");

	/** [U[͂. */
	private  Pattern pattern;

	/** ʂPsÂۑ. */
	 ArrayList<String[]> arrKekkaRow;

	/** ʕۑf[^NX. */
	 DataSearch dataSearch;

	/** sJEg. */
	private  int lines = 0;

	/**
	 *  𐳋K\.
	 * @param pat  
	 * @param capitalLetter 啶
	 */
	public  void compile(String pat,boolean capitalLetter) throws Exception , PatternSyntaxException {
		//pat = pat;
		if (capitalLetter == true) {
			/* 啶ʂ */
			pattern = Pattern.compile(pat);
		} else {
			/* 啶ʂȂ */
			pattern = Pattern.compile(pat,Pattern.CASE_INSENSITIVE);
		}
	}

	/**
	 *  t@CPsƌ.
	 * @param f               Ώۃt@C
	 * @param cb            Ώە CharBuffer
	 * @return ArrayList   t@Čʂ1sƂɕԂ
	 */
	private  ArrayList<String[]> grep(File f, CharBuffer cb)  throws IOException ,Exception {
		//Ⴄt@C̏ꍇsJE^[
/*		if (!fileFlg) {
			lines = 1;
		}*/

		/* 1s */
		Matcher lm = linePattern.matcher(cb);
		Matcher pm = null;			// Pattern matcher

		SearchApp.taskbarLbl.setText(f.getAbsolutePath()+ "@@");

		//System.out.println(" t@C: " + f);

		/** ʂPsÂۑ. */
		arrKekkaRow = new ArrayList<String[]>();
		dataSearch = new DataSearch();

		try {

		/* s*/
		while (lm.find()) {

			//sR[hΈȉs

			if( GrepTaskWorker.cancelbool ) {
				/* LZꂽ */
				return arrKekkaRow;
			}

//			//EOF \z ȊȌꍇisR[h̏ꍇjsJEg
//			if ( !(lm.group().matches(".*\\z" )) ) {
//				/** s. */
			lines++;
//			}

			CharSequence cs = lm.group(); 	// The current line

			if (pm == null) {
				/* s̕ɑ΂āA[U[͂w肷 */
				pm = pattern.matcher(cs);
			} else {
				pm.reset(cs);
			}

			if (pm.find()) {
				/* ͂ꂽlqbg */
				/** GREPʂPsÂzƂĕۑ. */
				/** ̏ꍇdȂ̂Ōʕ\e[uɂ͕؂̂Ăĕۑ */
				/** vX30܂ŕ\ */

				int txtLength = 0;
				String naiyoStr;

				/* vX30܂ŕ\ */
				if ((cs.length() - pm.end()) > 30) {
					txtLength =  pm.end() + 30;
					/* ؂̂Ăꍇ͍Ō c ǉ */
					naiyoStr = cs.subSequence(pm.start(), txtLength).toString().trim().concat(" c");
				} else {
					txtLength = cs.length();
					/* 30ȉȂ̂ł̂܂ܐݒ */
					naiyoStr = cs.subSequence(pm.start(), txtLength).toString().trim();
				}

				//System.out.println(": " + cs.length());
				//System.out.println("ݒ蒷: " + txtLength);
				//System.out.println("pm.end(): " + pm.end());

				//arrKekkaRow.add(dataSearch.setGrepNaiyouStr(f,String.valueOf(lines) , cs.toString().trim(), ""));
				//arrKekkaRow.add(dataSearch.setGrepNaiyouStr(f,String.valueOf(lines) , cs.subSequence(pm.start(), txtLength).toString().trim(), ""));
				arrKekkaRow.add(dataSearch.setGrepNaiyouStr(f,String.valueOf(lines) , naiyoStr, ""));
			}

			/* t@C̍ŌȂI */
			if (lm.end() == cb.limit()) {
				break;
			}
		}

		//System.out.println("");
		return arrKekkaRow;

		} finally {
			arrKekkaRow = null;
			dataSearch = null;
		}
	}

	// Search for occurrences of the input pattern in the given file
	//
	public  ArrayList<String[]> grep(File f,String encode) throws IOException ,Exception{

		// Open the file and then get a channel from the stream
		FileInputStream fis = new FileInputStream(f);
		FileChannel fc = fis.getChannel();

		MappedByteBuffer bb;

		CharBuffer cb;

		ArrayList<String[]> arrkekka = new ArrayList<String[]>();

		if( GrepTaskWorker.cancelbool ) {
			/* LZꂽ */
			fis.close();
			return arrkekka;
		}

		// Get the file's size and then map it into memory
		long sz = fc.size();
		//System.out.println("t@CTCY: " + sz + "  pX : " + f.getAbsolutePath());

		/* t@CTCY0̏ꍇ͌Ȃ */
		if (sz == 0) {
			fis.close();
			return arrkekka;
		}

		/* t@C̕R[hZbg */
		charset = Charset.forName(encode);
		decoder = charset.newDecoder();
		//System.out.println("R[hF" + encode);

		try {

			bb = fc.map(FileChannel.MapMode.READ_ONLY, 0, sz);
			// CharBufferɕϊ
			cb = decoder.decode(bb);
			// s
			arrkekka.addAll(grep(f,cb));

			return arrkekka;

		} finally {
			// Close the channel and the stream
			fc.close();
			bb = null;
			cb = null;
			fis.close();
			arrkekka = null;
		}
	}

	/**
	 * ExcelAWordt@CGREPp
	 * ŗ^ꂽalist(ArrList̒l)當̒loOgrepSearchNXIuWFNgŌ
	 * qbglbListadd.
	 *
	 * @param alist      (ArrayList)
	 * @param bList     Ńqbg(ArrayList)
	 * @param grepSearch NXIuWFNg
	 * @return
	 */
	public  ArrayList<String[]> getListGrep(ArrayList<String[]> alist,ArrayList<String[]> bList,GrepSearch grepSearch) {

		String cellKekkaStr[] = new String[5];

		String kekkaStr = "";

		for (int i = 0; i < alist.size(); i++) {

			cellKekkaStr = alist.get(i);
			/* Ŏ󂯎ArrayList̂RԖڂ當o */
			kekkaStr = cellKekkaStr[3];

			/*  */
			Matcher mcMoji = grepSearch.pattern.matcher(kekkaStr);

			if(mcMoji.find()) {
				/* Y镶񂪂ꍇԂ */
				bList.add(cellKekkaStr);
			}
		}
		return bList;
	}

	/**
	 * PDFt@Ĉfqdo.
	 *
	 * @param pdfFile       t@C
	 * @param pdfStr        镶
	 * @return
	 * @throws IOException
	 * @throws Exception
	 */
	public  ArrayList<String[]> getPDFGrep(File pdfFile,String pdfStr) throws IOException, Exception {

		/** PDFʕۑ. */
		ArrayList<String[]> arrPDFkekka = new ArrayList<String[]>();

		/* pdfStrCharBuffer𓾂 */
		CharBuffer cb =CharBuffer.wrap( pdfStr.subSequence(0, pdfStr.length()));

		/* PDFt@C */
		arrPDFkekka = grep(pdfFile,cb);

		return arrPDFkekka;
	}


	/**
	 * ʕ\e[u̐Fp.
	 * @param grepStr   (镶)
	 * @param textF     \Ă镶(Ώ)
	 * @param moziHyouziMax   nCCgő啶iȏ͌̕Ȃj
	 * @param mojiCheck 啶
	 *
	 * @return
	 */
	public  ArrayList<int[]> hightLiteGrep(String grepStr,String textF,int moziHyouziMax,boolean mojiCheck) throws Exception {

		/** ʈʒuۑ. */
		ArrayList<int[]> arrKekka = new ArrayList<int[]>();

		int position[];

		/* 镶𐳋K\ */
		compile(grepStr,mojiCheck);

		/* e[uɕ\镶 */
		Matcher mctxt = pattern.matcher(textF);

		while(mctxt.find()){  // }b`镶܂ތJԂ
			/* Ńqbg̈ʒuz֕ۑ */
			position = new int[2];
			position[0] = mctxt.start();
			position[1] = mctxt.end();

			arrKekka.add(position);

			//endő\傫ʒuɂȂꍇ͌𒆎~
			if ( position[1] > moziHyouziMax ) {
			   break;
			}

		}
		return arrKekka;
	}

	/**
	 *  t@C̕R[h𒲂ׂ  (t@C璲).
	 * @param file   t@C
	 * @return         R[h
	 * @throws       IOException
	 */
	public  String  getEncoding(File file) throws IOException ,NoClassDefFoundError ,Exception{
		/** R[h@ftHǵuSJISv */
		String strEncoding = "SJIS";

		byte[] buf = new byte[4096];

		java.io.FileInputStream fis = new java.io.FileInputStream(file.getAbsolutePath());

		UniversalDetector detector = new UniversalDetector(null);

		int nread;
		while ((nread = fis.read(buf)) > 0 && !detector.isDone()) {
			detector.handleData(buf, 0, nread);
		}

		detector.dataEnd();

		String encoding = detector.getDetectedCharset();
		if (encoding != null) {
			strEncoding = encoding;

		} else {
			strEncoding = "SJIS";
		}

		detector.reset();

		return strEncoding;

	}

	//	public static void main(String[] args) {

	//	MyGrep mgrep = new MyGrep();

	//	if (args.length < 2) {
	//	System.err.println("Usage: java Grep pattern file...");
	//	return;
	//	}
	//	/* 镶𐳋K\ */
	//	mgrep.compile(args[0]);
	//	/* t@C̐[v */
	//	for (int i = 1; i < args.length; i++) {
	//	/* t@C𓾂 */
	//	File f = new File(args[i]);
	//	try {
	//	mgrep.grep(f);
	//	} catch (IOException x) {
	//	System.err.println(f + ": " + x);
	//	}
	//	}
	//	}

}
