/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.TimeUnit;
import java.util.regex.PatternSyntaxException;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
import javax.swing.table.DefaultTableModel;

/**
 * GREPXbhŎs.
 * @author Yuu
 * @version 14.00
 * @since 2010-11
 */
public class GrepTaskWorker extends SwingWorker <String, String>  {

	private GrepTab grepTab;

	/** GrepNX. */
	private GrepSearch grepSearch;

	/** ExcelGrepNX. */
	private ExcelSearch excelSearch = new ExcelSearch();

	/** WordGrepNX. */
	private WordSearch wordSearch = new WordSearch();

	/** PDFt@CNX. */
	private PDFSearch pdfSearch = new PDFSearch();

	/** [U[͂Grep. */
	private String grepStr = "";

	/** [U[͂tH_. */
	private String folderStr = "";

	/** Office邩. */
	private boolean officeGrepBL = false;

	/** ʃeLXgzu^u. */
	//private MyJTabbedPaneS myTabbedPane;

	/** t@C. */
	private long allFileCount = 0;

	/** t@C. */
	private long fileCount = 0;

	/** qbgs. */
	private long rowCount = 0;

	int tableRow = 0;

	/** vOXo[\. */
	StringBuffer stbProg = new StringBuffer();

	/** G[e\. */
	StringBuffer stbErr = new StringBuffer();

	SearchApp seaApp;

	String strErr = " : ̓G[̂ߌł܂ł : ";

	/** LZꂽǂ(true=LZ false=sꂽ). */
	public static boolean cancelbool = true;

	/** ʕ\FύXtO. */
	String strTempSetColor = "";
	public static final String SET_COLOR = "iro";

	/** gqtB^[ɓ͂ꂽl. */
	public String inputExtentionStr = "";

	/** gq𕪂Ĕz֕ۑ. */
	public String extentionStr[];

	/** ʂ̍sۑ. */
	ArrayList<String[]> arrData;

	/** 啶 */
	public boolean mojiCheckBl = GrepTab.mojiCheck.isSelected();

	/** G[x(GREP). */
	private String errMojiStr = "Grep͂ĂB";

	/** G[x(pXAꏊ). */
	private String errFolderStr = "pXAꏊ͂ĂB";

	/** sX^[g. */
	public long startTime;
	/** sI. */
	public long endTime;
	/** oߎ. */
	public long BTime;

	/** oߎԕۑ. */
	public Long LHours;
	/** oߕۑ. */
	public Long LMinutes;
	/** oߕbۑ. */
	public Long LSeconds;
	/** \p̎.  */
	public StringBuffer stbTime = new StringBuffer();

	public GrepTaskWorker (SearchApp frame,GrepTab gTab) {
		grepTab = gTab;

		seaApp = frame;

		/* gqtB^[ɓ͂ꂽ𓾂 */
		inputExtentionStr = grepTab.filterCombB.getSelectedItem().toString();
		/* ؂蕶𔼊pXy[XƑSpXy[XǂłĔz֑ */
		extentionStr = inputExtentionStr.split(" |@");

	}

	/* ( Javadoc)
	 * @see javax.swing.SwingWorker#doInBackground()
	 *
	 * Xbhs execute() Ŏs
	 *
	 */
	@Override
	protected String doInBackground() throws Exception {
		// TODO ꂽ\bhEX^u

		cancelbool = false;

		// X^[gԕۑ
		startTime = System.currentTimeMillis();

		/** Grep͒l𓾂 */
		grepStr = grepTab.grepFileCombB.getSelectedItem().toString();

		/** 啶̃`FbNl𓾂. */
		mojiCheckBl = grepTab.mojiCheck.isSelected();

		/** tH_͒l𓾂 */
		folderStr = grepTab.pathCombB.getSelectedItem().toString();

		/* l͂̎G[_CAO\(GREP񖢓͂̏ꍇ) */
		if (grepStr.equals("")) {
			SearchApp.showMessage(errMojiStr);
			/* Ỉʐݒ */
			grepTab.threadEnd();
			return null;
		}

		/* l͂̎G[_CAO\(pXAꏊ͂̏ꍇ) */
		if (folderStr.equals("")) {
			SearchApp.showMessage(errFolderStr);
			/* Ỉʐݒ */
			grepTab.threadEnd();
			return null;
		}

		/* Ỏʐݒ */
		grepTab.threadStart();

		/** ͂ꂽpXFileNX */
		File pathFile = new File(folderStr);

		try {

			/* GREP */
			grepRefx(pathFile,GrepTab.refxCheck.isSelected());

		} catch (PatternSyntaxException x) {
			System.err.println(x.getMessage());
			stbErr.append(" K\̃G[ : ɃGXP[vuvĂ" + SearchApp.crlf);
			/* Iʐݒ */
			grepTab.threadEnd();
		}  catch (Exception err) {
			//System.out.println("G[ : " + err);
			stbErr.append(" G[ł " + SearchApp.crlf);
			/* Iʐݒ */
			grepTab.threadEnd();
		} catch (NoClassDefFoundError nce) {
			/*OjarCuǂݍ܂ȂƂG[\AI */
			/* G[_CAO\p */
			stbErr.append("Ojart@Cǂݍ߂܂łANĂB : " + nce.toString() + SearchApp.crlf);
			/* Iʐݒ */
			grepTab.threadEnd();
		} catch  (OutOfMemoryError e){
			//e.printStackTrace();
			/* G[_CAO\p */
			stbErr.append(strErr + e.toString() + SearchApp.crlf);
			//System.out.println("!!!!!! OutOfMemoryError: GREPُ !!!!!!");
			/* I */
			/* GREPI */
			if( !isDone() ) {
				cancel(true);
			}
		}

		return null;

	}

	/* ( Javadoc)
	 * @see javax.swing.SwingWorker#done()
	 *
	 * GREPXbhIs.
	 *
	 */
	protected void done() {
		grepTab.threadEnd();

		cancelbool = true;

		/*** Iԕۑ ***/
		endTime = System.currentTimeMillis();
		// vZ(~b)
		BTime = ( endTime - startTime );
		// bɕϊ
		LSeconds = TimeUnit.SECONDS.convert( BTime, TimeUnit.MILLISECONDS ) % 60;
		// 
		LMinutes = TimeUnit.MINUTES.convert( BTime,TimeUnit.MILLISECONDS  ) % 60;
		// 
		LHours = TimeUnit.HOURS.convert( BTime,TimeUnit.MILLISECONDS );
		// oߎԂ\pɕϊ
		stbTime = stbTime.append( ": " + BTime + "ms  " +  "(" + String.format("%d%d%db",LHours,LMinutes,LSeconds) + ") " );
		/*****  Ԃ܂ *****/

		/** vOXo[ɕ\Ă镶擾. */
		String pStr = getProgresStr();
		/* vOXo[ɕ\Ăʐe[uɕۑ */
		grepTab.resultGrepTable.setProgressBarStr(stbTime + pStr);
		/* ʉɕ\ */
		SearchApp.taskbarLbl.setText(stbTime + pStr + "@@");

		/* vOXo[XV(I̕t) */
		grepTab.progBar.setString(SearchApp.END_STR + pStr);

		/* Kx[WRNVs */
		 Runtime.getRuntime().gc();
		 /* [XV */
		SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
		SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);

		/* oߎԕ\ǉ */
		stbErr.append( stbTime + SearchApp.crlf );

		/* G[Ε\ */
		if (stbErr.length() > 0) {
			SearchApp.showTextMessage(seaApp, stbErr, "GREP̏IB G[̂e", JOptionPane.INFORMATION_MESSAGE);
		}
	}

	/**
	 * GREP@            tH_ċAIɎs.
	 * @param pathFile       t@C@tH_
	 * @param saikiFlg       ċAIɌ : true ċAȂ : false
	 * @throws IOException
	 */
	public void grepRefx(File pathFile, boolean saikiFlg) throws IOException,Exception,NoClassDefFoundError,OutOfMemoryError {

		if( isCancelled() ) {
			return;
		}

		/* tH_̏ꍇ(t@CtB^[ Ώۃt@C𓾂) */
		File listFile[] = pathFile.listFiles(new FileExtensionInitFilter(true));
		if ( listFile != null ) {
			/* tH_ƃt@C(tB^[ĕԂꂽt@C(Ώۃt@C)𓾂) */
			allFileCount += listFile.length;
		}

		/* tH_̏ꍇ(t@CtB^[t@C𓾂 ΏۊÕt@C𓾂)tB^[t@C邽߂ */
		File filterListFile[] = pathFile.listFiles(new FileExtensionInitFilter(false));
		/* tB^[t@CG[_CAOɕ\ */
		if ( filterListFile != null ) {
			for ( int i = 0; i < filterListFile.length; i++ ) {
				stbErr.append("ΏۊO: " + filterListFile[i].getAbsolutePath() + SearchApp.crlf);
			}
			/* tB^[t@C𓾂 */
			int filtedFilecount = filterListFile.length;
			/* tH_ƃt@C(tB^[t@CQ(ΏۊO)JEg) */
			allFileCount += filtedFilecount;
		}

		/* t@C̏ꍇGREP */
		if (pathFile.isFile()) {

			/* GREP */
			grepSearch(pathFile);

		} else {

			/* tH_̒g͌Ȃ */
			if ( listFile == null ) {
				return;
			}

			/* t@C̐[v */
			for (int i = 0; i < listFile.length; i++) {

				if (saikiFlg) {
					/* ċAIɌ */
					grepRefx(listFile[i],true);
				} else {
					/* ċAIł͂Ȃ */
					grepSearch(listFile[i]);
				}
			}
		}

	}


	/**
	 * vOXo[ɕ\镶쐬ĕԂ.
	 * @param allFileCount  t@C
	 * @param fileCount     t@C
	 * @param rowCount      qbgs
	 * @return              \镶Ԃ
	 */
	public String getProgresStr(long allFileCount,long fileCount,long rowCount) {

		stbProg.delete(0, stbProg.length());
		stbProg.append("@t@C,tH_ : ");
		stbProg.append(SearchApp.format.format(allFileCount));
		stbProg.append("@Yt@C : ");
		stbProg.append(SearchApp.format.format(fileCount));
		stbProg.append("@Ys : ");
		stbProg.append(SearchApp.format.format(rowCount));
		return stbProg.toString();
	}


	/**
	 * GREP.
	 * @param pathFile   t@C
	 * @param encoding   R[h
	 */
	public void grepSearch(File pathFile) throws NoClassDefFoundError,OutOfMemoryError,Exception {

		File gfile = new File(pathFile.getAbsolutePath());

		//		/* t@C */
		//		allFileCount += 1;
       /* vOXo[XV */
		grepTab.progBar.setString(getProgresStr(allFileCount,fileCount,rowCount));

		/* OfficeɃ`FbNĂꍇ true */
		officeGrepBL =  grepTab.officeCheck.isSelected();

		/** Õ`FbN */
		if( isCancelled() ) {
			/* LZꂽƂ */
			return;
		} else if( pathFile.isDirectory()) {
			/* fBNg̎ */
			return;
		} else if (!getFlgExtension(gfile)) {
			/* gq`FbN */
			return;
		} else if (grepTab.getGrepFlg(pathFile)) {
			/* t@CTCY`FbN */
			//System.out.println(" t@CTCYI[o[ ");
			/* G[_CAO\p */
			stbErr.append(gfile + " ̓t@CTCYI[o[(80Mbȏ)̂ߌł܂" + SearchApp.crlf);
			return;
		}

		grepSearch = new GrepSearch();
		//grepSearch = new BMSearch();
		/* 镶𐳋K\ */
		grepSearch.compile(grepStr,mojiCheckBl);
		BMSearch.compile(grepStr,mojiCheckBl);

		//ArrayList<String[]> arrData = new ArrayList<String[]>();
		arrData = new ArrayList<String[]>();

		/** Excel,Word,PDF t@CȊO. */
		boolean fileBL = true;

		try {

			if ( ( gfile.getPath().endsWith(".xls") || gfile.getPath().endsWith(".xlsx") ) ) {
				/* t@C̍Ōオ(gq)Excelt@C`FbN */
				/* falseɐݒ */
				fileBL = false;

				if ( officeGrepBL ) {
					/* Officeꍇ(Excel) */
					arrData = excelSearch.getExcelGrepString(gfile, grepSearch,this);
				}

			} else if ( ( gfile.getPath().endsWith(".doc") || gfile.getPath().endsWith(".docx") ) ) {
				/* t@C̍Ōオ(gq)Wordt@C`FbN */
				/* falseɐݒ */
				fileBL = false;

				if ( officeGrepBL ) {
					/* Officeꍇ(Word) */
					arrData = wordSearch.getWordGrep(gfile,grepSearch);
				}

			} else if (  gfile.getPath().endsWith(".pdf") ||  gfile.getPath().endsWith(".PDF") ) {
				/* t@C̍Ōオ(gq)pdft@C`FbN */
				/* falseɐݒ */
				fileBL = false;

				if ( officeGrepBL ) {
					/* PDFt@Cꍇ */
					arrData = pdfSearch.getPDFFileGrep(gfile, grepSearch);
				}

			} else if ( fileBL ) {
				/*  Grep(Excel,Word,PDFȊÕt@C) */
				/*  vpeBݒʂŐݒ肵@Ō     */
				if ( ConfigDialog.strSearch.equals("K\") ) {
					arrData = grepSearch.grep(gfile,getEncode(gfile));
				} else if ( ConfigDialog.strSearch.equals("(1)") ) {
					arrData = BMSearch.grep(gfile,getEncode(gfile));
				} else if ( ConfigDialog.strSearch.equals("(2)") ) {
					arrData = BMSearch.grepBufferR(gfile);
				} else {
					SearchApp.showMessage("uj[vuvpeBvu@^uv猟@IĂB");
				}
			}

			/* qbgt@C */
			if ( arrData.size() >0 ) {
				/* qbgt@C */
				fileCount += 1;
			}

			/* qbgs */
			rowCount += arrData.size();

            /* vOXo[XV */
			grepTab.progBar.setString(getProgresStr(allFileCount,fileCount,rowCount));
			 /* [XV */
			SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
			SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);

		} catch (IOException e) {
			// TODO ꂽ catch ubN
			//e.printStackTrace();
			/* G[_CAO\p */
			stbErr.append(gfile + strErr + e.toString() + SearchApp.crlf);
		} catch (Exception e) {
			// TODO ꂽ catch ubN
			//e.printStackTrace();
			/* G[_CAO\p */
			stbErr.append(gfile + strErr + e.toString() + SearchApp.crlf);
//		} catch  (OutOfMemoryError e){
//			e.printStackTrace();
//			/* G[_CAO\p */
//			stbErr.append(gfile + strErr + e.toString() + SearchApp.crlf);
//			System.out.println("!!!!!! OutOfMemoryError: GREPُ !!!!!!");
		}

		/* e[uʕ\Ńt@CƂɐFύX̂߂̏@ɗ"P"̃t@CɂGREPIĂ̂łŐF̒l݂ɐݒ肷鏈 */
		/* ݂́he[uhɕ\Ă錟ʂ̃f[^𓾂 */
		DefaultTableModel df = grepTab.resultGrepTable.getDfTable();
		if (df != null && df.getRowCount() != 0) {
			/* f[^ꍇ(0sȂ)͏Ȃ */
			/* ʕ\f[^ɒlꍇAŌ̐F̒l𓾂ĂƔ΂̐Fꎞϐɕۑ */
			/* ݕ\Ăf[^ōŌ̌ʃf[^e[uoF̒l`FbNB ̐FƔ΂̐FstrTempSetColorꎞϐɌ݂ɑ */
			strTempSetColor = ( df.getValueAt(df.getRowCount() -1,df.getColumnCount() -1) == SET_COLOR ? "" : SET_COLOR);
		}

		/* Ńe[uɌʂ̒lB̑OstrTempSetColorꎞϐɂlf[^ɓɒǉ */
		/* GREPʂ\Ăe[u֒ǉAs */
		for (int i = 0; arrData.size() > i; i++) {

			/* s̃f[^(z)o */
			String naiyouStr[] = arrData.get(i);
			/* F̃f[^Zbg z̍Ō*/
			naiyouStr[naiyouStr.length - 1] = strTempSetColor;

			/* ʂe[u֍sǉ  */
			grepTab.resultGrepTable.addTableRow( arrData.get(i) );

			tableRow = grepTab.resultGrepTable.getRowCount();
		}

		arrData = null;

		//grepSearch = null;

		SearchApp.getMemInfo();
		/* Kx[WRNVs */
		if ( SearchApp.meminfoGC > 85.0 ) {
		   Runtime.getRuntime().gc();
		}
	}

	/**
	 * R[h𓾂 (t@C璲ׂA͂Ăꍇ͂̃R[h).
	 * @param file          t@C
	 * @return                R[h
	 * @throws IOException
	 * @throws Exception
	 */
	public String getEncode(File file) throws IOException,NoClassDefFoundError,Exception {

		String encode = "";

		if (grepTab.codeCombB.getSelectedItem().toString().equals("")) {
			/* t@C當R[h𒲍 */
			encode = grepSearch.getEncoding(file);

		} else {
			/* ͂ꂽR[h */
			encode = grepTab.codeCombB.getSelectedItem().toString();

		}

		return encode;
	}

	/**
	 * gq`FbN.
	 * @param file         gq`FbNt@C
	 * @return boolean   true : gqOK ,  false  :  gqNG
	 */
	public boolean getFlgExtension(File file) {

		boolean flg = false;

		//System.out.println(" t@C : " + file);

		/* gq͂Ȃꍇ͑St@C trueݒ()ă\bhI */
		if (inputExtentionStr == null | inputExtentionStr == "") {
			return true;
		}

		/* t@C̍Ō(gq)A͂ꂽlƓ̂ꍇtrue()Ԃă\bhI */
		for (int i = 0; i < extentionStr.length; i++) {

			//System.out.println(" gq : " + extentionStr[i]);

			if (file.getPath().endsWith(extentionStr[i].toLowerCase())
					|| file.getPath().endsWith(extentionStr[i].toUpperCase())
					|| file.getPath().equalsIgnoreCase(extentionStr[i].toUpperCase())) {
				return true;
			}
		}

		/* gqtB^[ɂȂt@C̏ꍇ false (Ȃ)Ԃ  */
		return flg;
	}

	public String getProgresStr() {
		return stbProg.toString();
	}


}
