/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.CubicCurve2D;

import javax.swing.UIManager;
import javax.swing.plaf.synth.SynthContext;
import javax.swing.plaf.synth.SynthPainter;


public class MyBackgroundPainter extends SynthPainter {	

	public void paintPanelBackground(SynthContext context,Graphics g, int x, int y,int w, int h) 
	{
		Color start = UIManager.getColor("Panel.startBackground");
		Color end = UIManager.getColor("Panel.endBackground");
		Graphics2D g2 = (Graphics2D)g;
		GradientPaint grPaint = new GradientPaint(
				(float)x, (float)y, start,
				(float)w, (float)h, end);
		g2.setPaint(grPaint);
		g2.fillRect(x, y, w, h);
		g2.setPaint(null);
		g2.setColor(new Color(255, 255, 255, 120));
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
	}
}
