/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.nio.charset.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.regex.*;

import org.mozilla.universalchardet.UniversalDetector;

/**
 * @author Yuu
 * @version 14.00
 * @since 2016-12-20
 */
public class BMSearch {

	/** R[h. */
	private static Charset charset;
	private static CharsetDecoder decoder;

	/** [U[͂. */
	private static String pattern;

	/** 啶(True=啶ʂ@False=啶ʂȂ). */
	private static Boolean mojiBl;

	/** ʂPsÂۑ. */
	static ArrayList<String[]> arrKekkaRow;

	/** ʕۑf[^NX. */
	static DataSearch dataSearch;

	/** sJEg. */
	private int lines = 1;

	/**
	 *  ۑ.
	 * @param pat  
	 * @param capitalLetter 啶
	 */
	public static  void compile(String pat,boolean capitalLetter) throws Exception , PatternSyntaxException {
		pattern = pat;
		mojiBl = capitalLetter;
		//			if (capitalLetter == true) {
		//				/* 啶ʂ */
		//				pattern = pat;
		//			} else {
		//				/* 啶ʂȂ */
		//				pattern =pat;
		//			}
	}

	/**
	 *  t@CPsƌ.
	 * @param f               Ώۃt@C
	 * @param cb            Ώە CharBuffer
	 * @return ArrayList   t@Čʂ1sƂɕԂ
	 */
	private static ArrayList<String[]> grep(File f, CharBuffer cb)  throws IOException ,Exception {

		// Xe[^Xo[Ɍ̃t@C\
		SearchApp.taskbarLbl.setText(f.getAbsolutePath()+ "@@");

		/** ʂPsÂۑ. */
		arrKekkaRow = new ArrayList<String[]>();
		dataSearch = new DataSearch();

		/** ʓe\. */
		String naiyoStr;

		/** ʂ̈ʒu. */
		int kekkaPosi = 0;

		/** s. */
		int rowCount = 0;

		/** X^[gʒu. */
		int startPosi = 0;

		/** Iʒu. */
		int endPosi = 0;

		try {

			/** CharBufferꎞۑp. */
			CharBuffer cb2 = cb;

			//System.out.println( " ̒:  " + cb2.length() );

			while ( startPosi < cb.length() ) {

				cb2 = cb.subSequence(startPosi,cb.length());

				if (  lineSeparator(cb2) == -1 ) {
					endPosi = cb.length();
				} else {
					endPosi = endPosi + lineSeparator(cb2) + 1;
				}

				// s
				rowCount = rowCount + 1;
				// CharBufferɕۑ
				cb2 = cb.subSequence(startPosi, endPosi);

				//System.out.println( "  sF " + rowCount + "  F " + cb2.toString() );

				// 
				kekkaPosi = bmSearch(f,cb2,pattern);

				if ( kekkaPosi != -1 ) {
					/* vX30܂ŕ\ */
					if ((cb2.length() - kekkaPosi) > 30) {
						/* ؂̂Ăꍇ͍Ō c ǉ */
						naiyoStr =  cb2.subSequence(kekkaPosi, kekkaPosi + 30).toString().trim().concat(" c");
					} else {
						/* 30ȉȂ̂ł̂܂ܐݒ */
						naiyoStr =  cb2.subSequence(kekkaPosi,cb2.length()).toString().trim();
					}
					// 
					arrKekkaRow.add(dataSearch.setGrepNaiyouStr(f,String.valueOf(rowCount) , naiyoStr , ""));
				}
				// X^[gʒuݒ
				startPosi = endPosi + 1;
			}

			//I
			return arrKekkaRow;

		} finally {
			arrKekkaRow = null;
			dataSearch = null;
		}
	}

	/**
	 *  BM   CharBuffergp.
	 * @param f                                  Ώۂ̃t@C
	 * @param encode                       R[h
	 * @return                                    ̌
	 * @throws IOException
	 * @throws Exception
	 */
	public static ArrayList<String[]> grep(File f,String encode) throws IOException ,Exception{

		// FileChannel擾
		FileInputStream fis = new FileInputStream(f);
		FileChannel fc = fis.getChannel();

		MappedByteBuffer bb;

		CharBuffer cb;

		ArrayList<String[]> arrkekka = new ArrayList<String[]>();

		if( GrepTaskWorker.cancelbool ) {
			/* LZꂽ */
			fis.close();
			return arrkekka;
		}

		// t@C̃TCY
		Long sz = fc.size();

		/* t@CTCY0̏ꍇ͌Ȃ */
		if (sz == 0) {
			fis.close();
			return arrkekka;
		}

		/* t@C̕R[hZbg */
		charset = Charset.forName(encode);
		decoder = charset.newDecoder();
		//System.out.println("R[hF" + encode);

		try {

			bb = fc.map(FileChannel.MapMode.READ_ONLY, 0, sz);

			// CharBufferɕϊ
			cb = decoder.decode(bb);
			// s
			arrkekka.addAll(grep(f,cb));

			return arrkekka;

		} finally {
			// I
			fc.close();
			bb = null;
			cb = null;
			fis.close();
			arrkekka = null;
		}
	}


	/**
	 * BM@Ō.
	 * @param f                 t@C.
	 * @param cb              t@CCharBuffer.
	 * @param inpStr        .
	 * @return                   Ώۃt@C̕ʒu   -1 Ԃ.
	 */
	public static int bmSearch(final File f,final CharBuffer cb,final String inpStr) {

		/*** ړ镶ۑO  *********************/
		HashMap map = new HashMap();
		for(int i = 0; i < inpStr.length(); i++) {
			// p^[Ɋ܂܂Ă镶́Aɂ킹Ă炷
			// ӂ܂Ăꍇ́A
			// Ōɓoꂷ镶ɍ킹
			map.put(inpStr.charAt(i), inpStr.length() - i -1);
		}
		/*************************************************/

		/** t@CeLXg̃|WV. */
		int ftxtP = 0;

		/** ̃|WV. */
		int inpStrP = inpStr.length() - 1;

		Boolean mapBl = true;

		// t@CeLXg̃|WV̌ɐݒ
		ftxtP = inpStrP;

		//t@CeLXg̒[v
		while ( ftxtP  < cb.length() ) {

			/* ̌ɐݒ */
			inpStrP = inpStr.length() - 1;

			//̕[v
			for ( int i = 0; i < inpStr.length(); ++i  ) {

				//					if ( Character.isUpperCase(  cb.charAt(ftxtP) ) ) {
				//					/* 啶̏ꍇ */
				//
				//					} else {
				//
				//					}

				if ( mojiBl ) {
					/**********   啶ʂĔr(͂ꂽ܂܌)       **********/
					if ( cb.charAt(ftxtP) == inpStr.charAt(inpStrP) ) {
						if ( inpStrP == 0 ) {
							// ʒu0擪瓯
							// ʁ@̈ʒuԂ
							return ftxtP;
						}
						//1OɈړđ
						ftxtP = ftxtP - 1;
						inpStrP = inpStrP - 1;
					}
				} else {
					/**********   啶ʂȂŔr (`FbNȂftHg)          **********/
					if ( String.valueOf( cb.charAt(ftxtP) ).equalsIgnoreCase( String.valueOf( inpStr.charAt(inpStrP) ) ) ) {
						if ( inpStrP == 0 ) {
							// ʒu0擪瓯
							// ʁ@̈ʒuԂ
							return ftxtP;
						}
						//1OɈړđ
						ftxtP = ftxtP - 1;
						inpStrP = inpStrP - 1;
					}
				}
			}

			/* t@CeLXgɂ邩`FbN */
			mapBl = map.containsKey(cb.charAt(ftxtP));

			/** ̈ʒu. */
			int mapInt = 0;

			if ( mapBl ) {
				mapInt = (int)map.get(cb.charAt(ftxtP));
			} else {
				mapInt = inpStr.length();
			}

			if( mapInt > inpStr.length() - inpStrP){
				// |WVړ
				ftxtP += mapInt;
			} else {
				//
				ftxtP += inpStr.length() - inpStrP;
			}
		}
		// vȂꍇ -1 Ԃ
		return -1;
	}

	/**
	 * sR[ḧʒuԂ.
	 * @param cb       sR[hT.
	 * @return            sR[ḧʒu   -1 .
	 */
	public static int lineSeparator (final CharBuffer cb) {

		/** sR[h. */
		char sep[] = {'\r','\n',};

		for ( int i = 1; i < cb.length(); ++i ) {

			for (int j = 0; j < sep.length; ++j) {
				if ( cb.charAt(i) == sep[j] ) {
					return i;
				}
			}
		}
		return -1;
	}

	/**
	 *  t@C̕R[h𒲂ׂ  (t@C璲).
	 * @param file   t@C
	 * @return         R[h
	 * @throws       IOException
	 */
	public static String  getEncoding(File file) throws IOException ,NoClassDefFoundError ,Exception{
		/** R[h@ftHǵuSJISv */
		String strEncoding = "SJIS";

		byte[] buf = new byte[4096];

		java.io.FileInputStream fis = new java.io.FileInputStream(file.getAbsolutePath());

		UniversalDetector detector = new UniversalDetector(null);

		int nread;
		while ((nread = fis.read(buf)) > 0 && !detector.isDone()) {
			detector.handleData(buf, 0, nread);
		}

		detector.dataEnd();

		String encoding = detector.getDetectedCharset();
		if (encoding != null) {
			strEncoding = encoding;

		} else {
			strEncoding = "SJIS";
		}

		detector.reset();

		return strEncoding;

	}

	/**
	 * 񌟍 BufferedReader1sÂǂ݂Ȃ猟.
	 * @param fl                                  path.
	 * @return ArrayList<String>        .
	 * @throws Exception
	 * @throws NoClassDefFoundError
	 */
	public static ArrayList<String[]> grepBufferR(File fl) throws NoClassDefFoundError, Exception {

		// Xe[^Xo[Ɍ̃t@C\
		SearchApp.taskbarLbl.setText(fl.getAbsolutePath()+ "@@");

		//BufferedReader reader;
		//StringBuilder builder = new StringBuilder();
		String strLine;

		/** ʂPsÂۑ. */
		arrKekkaRow = new ArrayList<String[]>();
		dataSearch = new DataSearch();

		/** ʓe. */
		String naiyoStr;

		/** ʂ̈ʒu. */
		int kekkaPosi;

		/** s. */
		int rowCount = 0;

		// R[h擾
		String encodStr = getEncoding( fl );

		try {

			BufferedReader reader = new BufferedReader
					( new InputStreamReader(new FileInputStream(fl),encodStr) );

			while ( (strLine = reader.readLine() ) != null){
				// s
				rowCount = rowCount + 1;
					// 
					//kekkaPosi = bmSearch(fl,string,pattern);
					kekkaPosi = bmSearch(fl,CharBuffer.wrap(strLine),pattern);
					//kekkaPosi = -1;
					//System.out.println(" ʒu: " + kekkaPosi);

					if ( kekkaPosi != -1 ) {
						/* vX30܂ŕ\ */
						if ((strLine.length() - kekkaPosi) > 30) {
							/* ؂̂Ăꍇ͍Ō c ǉ */
							naiyoStr =  strLine.substring(kekkaPosi, kekkaPosi + 30).trim().concat(" c");
						} else {
							/* 30ȉȂ̂ł̂܂ܐݒ */
							naiyoStr =  strLine.substring(kekkaPosi).trim();
						}
						//
						arrKekkaRow.add(dataSearch.setGrepNaiyouStr(fl,String.valueOf(rowCount) , naiyoStr , ""));
					}
				}

			reader.close();

			return arrKekkaRow;

		} finally {
			arrKekkaRow = null;
			dataSearch = null;
		}
	}

	public static void main (String args[]) {

		//BMSearch bm = new BMSearch();
		try {

			//System.out.println("I");
		} catch (NoClassDefFoundError e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		} catch (Exception e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}

	}

}
