/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.Component;
import java.io.File;
import java.util.Arrays;

import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeWillExpandListener;
import javax.swing.filechooser.FileSystemView;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.ExpandVetoException;
import javax.swing.tree.TreePath;


/**
 * tH_t@Cc[`ŕ\.
 * @author Yuu
 * @version 14.00
 * @since 2010-10-18
 */
public class DirTree  extends JTree implements TreeSelectionListener {

	/** hCuۑ.*/
	private static File[] drive;

	/** m[h. */
	private DefaultMutableTreeNode rootNode;
	/** JTreẽf[^Ǘ. */
	private DefaultTreeModel treeModel;
	/** JTreẽ[g̎q̐.  */
	private int rootNodeCount;

    /** _IuWFNg. */
    ComTreeCellRenderer treeRenderer = new ComTreeCellRenderer();

	DirTree() {

		/* [g쐬 */
		rootNode = new DefaultMutableTreeNode("root");

		treeModel = new DefaultTreeModel(rootNode);

		createRootTree(getDrive());
		//createRootTree(FileSystemView.getFileSystemView().getRoots());

		/* JTreeTreeModelZbg */
		this.setModel(treeModel);

		/** JTreeCxg */
		this.addTreeWillExpandListener(new TreeWillExpandListener() {
			public void treeWillExpand(TreeExpansionEvent e) {
				TreePath tp = e.getPath();
				/* NbNm[h擾 */
				File file = getSubDirList(tp);
				addExpandTree(tp,file);
				/* c[̃[g擾 */
				File rootfile = new File((String)treeModel.getRoot().toString());
			}

			/**
			 * JTree܂肽܂鎞ɌĂ΂.
			 * @Override
			 * (non-Javadoc)
			 * @see javax.swing.event.TreeWillExpandListener#treeWillCollapse(javax.swing.event.TreeExpansionEvent)
			 */
			public void treeWillCollapse(TreeExpansionEvent event)
			throws ExpandVetoException {
			}

		});

		/*  0̈ʒuɂ̂WJĕ\ */
		this.expandRow(0);
		/* [g\ */
		this.setRootVisible(false);

        /* ACR_ɃACRo^@*/
//        treeRenderer.setLeafIcon(new ImageIcon( SearchApp.iconUrl[1]));
//        treeRenderer.setOpenIcon(new ImageIcon( SearchApp.iconUrl[0]));
        //treeRenderer.setClosedIcon(closeIcon);
        /* _c[ɓo^ */
        this.setCellRenderer(treeRenderer);

	}

	/**
	 *  Filez񂩂JTreeroot쐬.
	 *
	 *  @param   rootFile   rootɂFilez (hCuȂ)
	 *
	 *
	 * */
	public void createRootTree(File[] rootFile) {

		rootNode.removeAllChildren();
		treeModel.reload();

		for (int i = 0; i < rootFile.length; i++) {
			DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(rootFile[i].toString());
			childNode.add(new DefaultMutableTreeNode(""));
			rootNode.add(childNode);
		}

	}

	/**
	 * TreePathpX𐶐.
	 *
	 * @param treepath
	 * @return  File
	 */
	public static File getSubDirList(TreePath treepath) {
		if(treepath == null) {
			return null;
		}

		/* pX */
		String pathStr = "";

		/* ɃpXJEg擾 */
		int count = treepath.getPathCount();

		for(int i = 1; i < count; i++) {
			pathStr += treepath.getPathComponent(i).toString();   //m[h擾

			if (i + 1 == count) {
				break;
			} else {
				/* VXeˑ̃pX؂ǉ */
				pathStr += File.separator;
			}
		}
		return new File(pathStr);    //File^IuWFNg𐶐

	}

	/**
	 * XgƓWJp̃c[쐬.
	 * @param tp
	 * @param myfile
	 */
	public void addExpandTree(TreePath tp,File myfile) {
		File templist[];

		if(myfile == null)
			return;

		//c[pX̍ŌR|[lg擾 NbNtH_̃pX̍Ō(NbNtH_)擾
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)tp.getLastPathComponent();

		if(node == null) {
			return;
		}
		if(myfile.isFile() == false) {
			templist = myfile.listFiles();  //TufBNgXg
			//Xg̏ꍇ͏Ȃ
			if(templist == null || templist.length == 0) {
				return;
			}

			node.removeAllChildren();
			for(int i = 0; i < templist.length; i++){

				DefaultMutableTreeNode temp = new
				DefaultMutableTreeNode(templist[i].getName());
				String strtemp = templist[i].getName();
				node.add(temp);
				/* t@CȂ_~[̎q쐬Ă tH_\̂ */
				if(templist[i].isDirectory()){
					File[] files = templist[i].listFiles();
					if(files == null || files.length == 0){
						DefaultMutableTreeNode tempsub =
							new DefaultMutableTreeNode(new DefaultMutableTreeNode(""));
						temp.add(tempsub);
						continue;
					}
					Arrays.sort(files);

					for(int j = 0; j < files.length; j++){
						DefaultMutableTreeNode tempsub =
							new DefaultMutableTreeNode(files[j].getName());
						temp.add(tempsub);
					}
				}
			}
		}
	}


	/**
	 *  hCuԂ.
	 * @return
	 */
	public File[] getDrive() {
		/** hCu擾 */
		drive = File.listRoots();
		return drive;
	}

	/**
	 *  hCuԂ Object.
	 * @return
	 */
	public static Object[] getDriveOb() {
		/** hCu擾 */
		drive = File.listRoots();
		return (Object[])drive;
	}

	//@Override
	public void valueChanged(TreeSelectionEvent e) {
		// TODO ꂽ\bhEX^u

	}

//	public static void main(String[] args) {
//
//		JFrame myf = new JFrame();
//		DirTree myTree = new DirTree();
//
//		myf.getContentPane().add(myTree);
//		myf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//		myf.setBounds(10, 10, 400, 500);
//		myf.setTitle("^Cg");
//		myf.setVisible(true);
//
//
//	}

}


/**
 *  JTree̕`
 *  t@CAtH_̃ACR\.
 * @author Yuu
 *
 */
class ComTreeCellRenderer extends  DefaultTreeCellRenderer {

	private static final long serialVersionUID = 1L;
	/* VXẽACR擾 16~16 */
	//FileSystemView fileSystemV = FileSystemView.getFileSystemView();
	//DirTree dTree = new DirTree();
	File fl;

	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expandes, boolean leaf,
			int row, boolean hasFocus) {
		// TODO ꂽ\bhEX^u
		super.getTreeCellRendererComponent(tree, value, selected, expandes,leaf,row,hasFocus);

		String valueStr = value.toString().trim();
		fl = DirTree.getSubDirList(tree.getPathForRow(row));
		JLabel label = new JLabel();
		label.setText(FileSystemView.getFileSystemView().getSystemDisplayName(new File(valueStr)));
		label.setOpaque(true);
		//System.out.println("t@C: " + fl);

		label.setIcon(FileSystemView.getFileSystemView().getSystemIcon( fl ));
		/* VXẽACR擾 32~32 */
		//ShellFolder.getShellFolder(new File(valueStr)).getIcon(true);
		//label.setIcon(fileSystemV.getSystemIcon(new File(valueStr)));

		if (selected) {
			label.setForeground(UIManager.getColor("Tree.selectionForeground"));
			label.setBackground(UIManager.getColor("Tree.selectionBackground"));
		} else {
			label.setForeground(UIManager.getColor("Tree.foreground"));
			label.setBackground(UIManager.getColor("Tree.background"));
		}
		return label;
	}

}

