/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.SwingWorker;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Grep^u ʃNX.
 * @author Yuu
 * @version 1.0
 * @since 2010-10-24
 */
public class GrepTab extends JPanel {

	JLabel grepName;
	JLabel pathName;
	JLabel filterName;
	JLabel codeName;

	/** GREP. */
	MyJComboBox grepFileCombB;
	/** pXAꏊ@. */
	MyJComboBox pathCombB;
	/** t@CtB^[. */
	MyJComboBox filterCombB;
	/** R[h. */
	MyJComboBox codeCombB;

	/** TutH_tO */
	static JCheckBox refxCheck = new JCheckBox("TutH_");
	/** 啶ʃtO */
	static JCheckBox mojiCheck = new JCheckBox("啶ʂ");
	/** OfficetO */
	static JCheckBox officeCheck = new JCheckBox("Office,PDF(Excel,Word,PDF)");

	/** K\ȊOł̌tO.  */
	//static Boolean flgReguEx = false;

	/** {^. */
	JButton searchGrepBtn = new JButton(" GREP ");;

	/** LZ{^. */
	JButton canceGreplBtn = new JButton(" LZ ");;

	/** io[\ */
	JProgressBar progBar = new JProgressBar();

	/** ʃe[u. */
	ITableResult resultGrepTable;
	JScrollPane scrollTable;

	/** ʃeLXgzu^u. */
	MyJTabbedPaneS myTabbedPane;

	/** ̓tB[hzupl. */
	JPanel searchGPane;

	/** CAEg. */
	GridBagLayout layout;
	/** gridx ͉@gridy͏c. */
	GridBagConstraints gbclayout;

	/** R[h */
	final static String[] strCode = {"","SHIFT-JIS","JIS","EUC","Unicode","UTF-8"};

	/** sXbh */
	//private final static String threadName = "searchGrep";

	/** ^u̖O. */
	private String tabName = "VK";

	/** GREP^uf. */
	public static String GREP_TAB = "GREPTAB";

	/** GREPXbh. */
	SwingWorker taskWorker;

	SearchApp seaApp;

	/**
	 * @param frame
	 */
	public GrepTab(SearchApp frame) {

		seaApp = frame;

		searchGPane = new JPanel();

		grepName = new JLabel(" 镶 ");

		pathName = new JLabel(" pXAꏊ ");

		filterName = new JLabel("<html>gqtB^[<br> ()@.txt .java .html");
		codeName = new JLabel("R[h");

		/** ʃe[u. */
		resultGrepTable = new TableResult();

		/* JProgressBar */
		progBar.setStringPainted(true);

		progBar.setString("");
		progBar.setValue(0);

		scrollTable = new JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollTable.getViewport().setView((Component) resultGrepTable);
		scrollTable.setPreferredSize(new Dimension(300,250));

		/** ʃeLXgzu^u. */
		myTabbedPane = new MyJTabbedPaneS();
		myTabbedPane.add(tabName,scrollTable);

		String[] combStr = {""};
		grepFileCombB = new MyJComboBox(combStr);
		grepFileCombB.setEditable(true);

		pathCombB = new MyJComboBox(new String[]{""});
		pathCombB.setEditable(true);

		filterCombB = new MyJComboBox(new String[]{""});
		filterCombB.setEditable(true);
		filterCombB.setToolTipText("<html>w肷ꍇXy[Xŋ؂ē<br>.java .txt .html<br>(͒lꍇ͑SΏ)</html>");

		codeCombB = new MyJComboBox(strCode);
		codeCombB.setEditable(true);

		layout = new GridBagLayout();
		gbclayout = new GridBagConstraints();

		this.setLayout(new BorderLayout());

		/** ̓tB[hzupl̃CAEg */
		searchGPane.setLayout(layout);

		/**                                                                                    *
		 * JLabel̔zuʒu@u镶́vx(0,0)         *
		 *                                                                                      */
		gbclayout.gridx = 0;
		gbclayout.gridy = 0;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(10,4,3,4);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(grepName, gbclayout);

		/**                                                                              *
		 *  u镶́v JComboBox̔zuʒu@(1,0)  *
		 *                                                                                */
		gbclayout.gridx = 1;
		gbclayout.gridy = 0;
		/** tH_At@C JComboBox̔zu */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 3;

		//gbclayout.weightx = 1.0d;

		gbclayout.insets = new Insets(10,4,3,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(grepFileCombB, gbclayout);

		/**                                                                          *
		 *  JLabel̔zuʒu upXAꏊvx@(0,1)         *
		 *                                                                            */
		gbclayout.gridx = 0;
		gbclayout.gridy = 1;
		//		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.weightx = 0;
		gbclayout.weighty = 0;

		gbclayout.insets = new Insets(4,4,2,4);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(pathName, gbclayout);

		/**                                                                                              *
		 *  pXAꏊ@ JComboBox pathCombB̔zuʒu@(1,1)         *
		 *                                                                                                */
		gbclayout.gridx = 1;
		gbclayout.gridy = 1;

		/** pXAꏊ@ JComboBox̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 3;

		//gbclayout.weightx = 1.0d;

		gbclayout.insets = new Insets(4,4,2,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(pathCombB, gbclayout);

		/**                                                        *
		 *  TutH_`FbN{bNXzu  *
		 *                                                          */
		gbclayout.gridx = 0;
		gbclayout.gridy = 2;
		/** TutH_`FbN{bNXzuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(3,30,2,10);
		gbclayout.fill = GridBagConstraints.CENTER;
		layout.setConstraints(refxCheck, gbclayout);

		/**                                             *
		 *  啶`FbN{bNXzu      *
		 *                                               */
		gbclayout.gridx = 1;
		gbclayout.gridy = 2;
		/** 啶`FbN{bNXzuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(3,15,2,4);
		gbclayout.fill = GridBagConstraints.NONE;
		//gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(mojiCheck, gbclayout);

		/**                                                       *
		 *  Office`FbN{bNXzu           *
		 *                                                         */
		gbclayout.gridx = 2;
		gbclayout.gridy = 2;
		/** Office`FbN{bNXzuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 0;

		gbclayout.insets = new Insets(3,10,2,4);
		gbclayout.fill = GridBagConstraints.NONE;
		layout.setConstraints(officeCheck, gbclayout);

		/**                                                                            *
		 * JLabel̔zuʒu  ugqtB^[́vx      *
		 *                                                                              */
		gbclayout.gridx = 0;
		gbclayout.gridy = 3;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(2,4,3,1);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(filterName, gbclayout);


		/**                                                                              *
		 *  ugqtB^[́v JComboBox̔zuʒu         *
		 *                                                                                */
		gbclayout.gridx = 1;
		gbclayout.gridy = 3;
		/** tH_At@C JComboBox̔zu */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.weightx = 1.0d;

		gbclayout.insets = new Insets(2,4,3,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(filterCombB, gbclayout);

		/**                                   *
		 * JLabel̔zuʒu            *
		 *                                     */
		gbclayout.gridx = 2;
		gbclayout.gridy = 3;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(2,1,3,1);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.CENTER;

		layout.setConstraints(codeName, gbclayout);

		/**                                                                         *
		 *  R[h JComboBox̔zuʒu                   *
		 *                                                                           */
		gbclayout.gridx = 3;
		gbclayout.gridy = 3;
		/** tH_At@C JComboBox̔zu */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.weightx = 1.0d;

		gbclayout.insets = new Insets(2,2,3,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.EAST;
		layout.setConstraints(codeCombB, gbclayout);

		/**                                                                   *
		 *  {^zu                                              *
		 *                                                                     */
		gbclayout.gridx = 2;
		gbclayout.gridy = 4;
		/** {^̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.weightx = 0;

		gbclayout.insets = new Insets(2,5,2,5);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.EAST;
		layout.setConstraints(searchGrepBtn, gbclayout);

		/**                                                               *
		 *  LZ{^zu                                 *
		 *                                                                 */
		gbclayout.gridx = 3;
		gbclayout.gridy = 4;
		/** {^̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(2,5,2,5);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(canceGreplBtn, gbclayout);

		/**                                               *
		 *  io[zu                             *
		 *                                                 */
		gbclayout.gridx = 0;
		gbclayout.gridy = 5;
		/** io[̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 5;

		gbclayout.weightx = 1.0d;

		gbclayout.insets = new Insets(4,10,8,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(progBar, gbclayout);


		searchGPane.add(grepName);
		searchGPane.add(grepFileCombB);
		searchGPane.add(pathName);
		searchGPane.add(pathCombB);

		searchGPane.add(filterName);
		searchGPane.add(filterCombB);

		searchGPane.add(codeName);
		searchGPane.add(codeCombB);

		searchGPane.add(refxCheck);
		searchGPane.add(mojiCheck);
		searchGPane.add(officeCheck);
		searchGPane.add(searchGrepBtn);
		searchGPane.add(canceGreplBtn);
		searchGPane.add(progBar);

		this.add(searchGPane,BorderLayout.NORTH);
		this.add(myTabbedPane,BorderLayout.CENTER);

		/** {^Cxg. */
		searchGrepBtn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

				try {
					/*  */
					taskWorker = new GrepTaskWorker(seaApp,GrepTab.this);
					/* s */
					taskWorker.execute();
				} catch (Exception e1) {
					SearchApp.showTextMessage(seaApp, new StringBuffer(e1.toString()), "G[e", JOptionPane.INFORMATION_MESSAGE);
				}

			}
		});

		/** LZ{^Cxg. */
		canceGreplBtn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* Kx[WRNVs */
				 Runtime.getRuntime().gc();
				seaApp.repaint();
				 /* [XV */
				SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
				SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);

				/* GREPI */
				if(taskWorker!=null && !taskWorker.isDone()) {
					taskWorker.cancel(true);
				}
				taskWorker = null;
				//resultGrepTable = null;

			}
		});

		/**
		 * tH[JX𓾂ĂTab.
		 *
		 * */
		myTabbedPane.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				/* I\ĂTabJTextPasne𓾂 */
				scrollTable =  (JScrollPane) myTabbedPane.getSelectedComponent();
				ITableResult resultTable = (ITableResult)scrollTable.getViewport().getView();

				/* Xe[^Xo[Ɍʂ\ */
				SearchApp.taskbarLbl.setText(resultTable.getProgresBarStr() + "@@");
			}
		});

	}

	/**
	 * ʐݒ  uv{^gpsAio[\Ae[ȕ.
	 */
	public  void threadStart() {
		/* {^gpsɐݒ */
		searchGrepBtn.setEnabled(false);

		/* io[ */
		progBar.setIndeterminate(true);
		progBar.setVisible(true);

//		/** GREP͂ꂽǉݒ */
//		seaApp.setComboBoxStr(grepFileCombB);
		grepFileCombB.setComboBoxStr();

//		/** pX͂ꂽǉݒ */
//		seaApp.setComboBoxStr(pathCombB);
		pathCombB.setComboBoxStr();

//		/** gqtB^[͂ꂽǉݒ */
//		seaApp.setComboBoxStr(filterCombB);
		filterCombB.setComboBoxStr();

//		/** R[h͂ꂽǉݒ */
//		seaApp.setComboBoxStr(codeCombB);
		codeCombB.setComboBoxStr();

		/* Vʕ\^u쐬 */
		seaApp.creatTab(grepFileCombB.getSelectedItem().toString(), resultGrepTable, scrollTable, myTabbedPane,GrepTab.GREP_TAB);
	}

	/**
	 * GREP邩O`FbN
	 * 80MB傫t@C͌Ȃ.
	 *
	 * @param   grepFile  File
	 * @return  Ȃ(80MBȏ) true : (80MBȉ) false
	 */
	public boolean getGrepFlg(File grepFile) {
		/* 80MB傫t@C͌Ȃ */
		long size = 83886080;
		if ( grepFile.length() > size) {
			return true;
		}

		return false;
	}

	/**
	 * Iʐݒ@uv{^gpsAio[~.
	 */
	public void threadEnd() {
		/* {^gp\ɐݒ */
		searchGrepBtn.setEnabled(true);
		/* io[ */
		progBar.setIndeterminate(false);
	}


	/**
	 * ʕ\e[uԂ.
	 * @return ʕ\e[u(TableResult)IuWFNgԂ.
	 */
	public ITableResult getTableResult() {

		return resultGrepTable;
	}

	//	public static void main(String[] args) {

	//		JFrame myf = new JFrame();
	//		GrepTab myF = new GrepTab(myf);

	//		//myf.getContentPane().add(myF ,BorderLayout.NORTH);
	//		myf.getContentPane().add(myF);
	//		myf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	//		//myf.setBounds(10, 10, 400, 500);
	//		myf.pack();
	//		myf.setTitle("^Cg");
	//		myf.setVisible(true);


	//	}

}
