/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.Color;
import java.awt.Insets;
import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.Document;
import javax.swing.text.Highlighter;

/**
 * \ĂL[[h̐FςJTextFieldgNX
 * e[ũZɐݒuĕ\Ă镶̃L[[hύX
 * t@CtH_ɂăACR\.
 * @author Yuu
 */
public class TextFieldHighlighter extends JTextField  implements DocumentListener {

	/** F. */
	private static final Highlighter.HighlightPainter highlightPainter = new DefaultHighlighter.DefaultHighlightPainter(new Color(242,145,208));
	private Document doc;
	private Highlighter highlite;

	/** \Ă镶. */
	private String kekkaStr;

	/** . */
	private String grepStr = "";

	/** 啶A̔. */
	private boolean grepMojibool;

	/** wiF邩Ȃ true wiF false wiFȂ. */
	private boolean boolGrep;

	/** Fςp. */
	private GrepSearch grepsearch;

	/** ACRZbgĎgp. */
	private ImageIcon imgI;

	/** }[W̍쐬. */
	private Insets insets = this.getMargin();

	/** t@CAtH_̔. */
	private File fileJud;

	/** \Ăe[u̒̕l. */
	private int columnWidth = -1;

	/** ̕ŕ\łő啶. */
	private int moziHyouziMax = -1;

	/**
	 * \ĂL[[h̐FςJTextFieldgNX̃RXgN^.
	 * @param grepStr   
	 * @param columnW  \Ă񕝁i\Ă镶nCCgj
	 * @param bool        啶
	 * @param boolGrep wiF邩Ȃ
	 */
	TextFieldHighlighter(String grepStr,int columnW,boolean bool,boolean boolGrepTemp) {
		this.grepStr = grepStr;
		/* 啶A */
		grepMojibool = bool;
		/* wiF邩 */
		boolGrep = boolGrepTemp;

		grepsearch = new GrepSearch();

		columnWidth = columnW;

		getDocument().addDocumentListener(this);
	}

	/**
	 * JTextArea̔wiɐF郁\bh.
	 * @param grepStr          
	 * @param grepMojibool   啶
	 */
	public void setHighlight (String grepStr,boolean grepMojibool) {

		/* wiFȂꍇ͂Ń\bhIĈȌ㏈Ȃ */
		if (boolGrep == false) {
			return;
		}

		/** \ĂtHgTCY. */
		float fsize =  getFont().getSize2D();
		/* \ĂtHg̃TCY𓾂ipj */
		int fontSize = (int) (fsize/2);

		/* e[u̗ɕ\łő̕vZi܂R̕nCCgƓ삪xȂĵ
		 * moziHyouziMaxȏ̓nCCgȂ */
		moziHyouziMax = columnWidth/fontSize;

		/** ʈʒuۑ. */
		ArrayList<int[]> arrKekka = new ArrayList<int[]>();
		/** wiʒȕꏊ. */
		int position[]  = new int[2];

		try {
			highlite = getHighlighter();
			/* ʕ\̃eLXg𓾂 */
			doc = getDocument();
			kekkaStr = getText(0, doc.getLength());

			/* GREP\̂ߌ */
			arrKekka = grepsearch.hightLiteGrep(grepStr, kekkaStr,moziHyouziMax, grepMojibool);

			for (int i = 0; arrKekka.size() > i; i++) {
				/* Fς镶ʒuʂ𓾂 */
				position = arrKekka.get(i);

				highlite.addHighlight(position[0], position[1],highlightPainter);

			}

		} catch (BadLocationException  e) {
			e.printStackTrace();
		} catch (Exception e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
	}

	public void removeHighlights() {
		getHighlighter().removeAllHighlights();
	}

	//@Override
	public void insertUpdate(DocumentEvent e) {
		// TODO ꂽ\bhEX^u
	}

	//@Override
	public void removeUpdate(DocumentEvent e) {
		// TODO ꂽ\bhEX^u
	}

	//@Override
	public void changedUpdate(DocumentEvent e) {
		// TODO ꂽ\bhEX^u
	}


	/**
	 * \eLXgݒ.
	 * @param t                       \eLXg
	 * @param boolIconTemp    ACR\邩̔   true ACR\   :   false ACR\
	 */
	public void setText(String t,boolean boolIconTemp) {
		/* eLXgZbg */
		super.setText(t);
		/* ACR\ */
		setIcon("",boolIconTemp);
		/* wi̐F */
		setHighlight(grepStr,grepMojibool);
	}

	/**
	 * \eLXgݒ.
	 * @param t                       \eLXg
	 * @param file                    t@C(tpX)
	 * @param boolIconTemp    ACR\邩̔   true ACR\   :   false ACR\
	 */
	public void setText(String t,String file,boolean boolIconTemp) {
		/* eLXgZbg */
		super.setText(t);
		/* ACR\ */
		setIcon(file,boolIconTemp);
		/* wi̐F */
		setHighlight(grepStr,grepMojibool);
	}

	/**
	 * ACR̕\.
	 * @param fileStr               t@C(tpX)
	 * @param boolIconTemp   true   ACR\   :   false   ACR\
	 */
	public void setIcon(String fileStr,boolean boolIconTemp) {

		/* ACR\Ȃꍇ͂Ń\bhIăACR͕\Ȃ */
		if (boolIconTemp == false || SearchApp.boolIcon == false) {
			return;
		}

		/* ȍ~ACR\̂߂̐ݒ */
		/* tH_t@C̔̂߂ */
		fileJud = new File(fileStr);

		if (fileJud.isDirectory()) {
			/* tH_̏ꍇ */
			imgI = new ImageIcon(SearchApp.iconUrl[0]);
		} else if (fileJud.isFile()) {
			/* t@C̏ꍇ */

			/* ܂ʂ̃t@CACRݒ */
			imgI = new ImageIcon(SearchApp.iconUrl[1]);

			if ( fileJud.getPath().endsWith(".xls") || fileJud.getPath().endsWith(".xlsx") ) {
				/* Excelt@C̏ꍇ̊gq@ExcelACRݒ */
				imgI = new ImageIcon(SearchApp.iconUrl[2]);
			} else if ( fileJud.getPath().endsWith(".doc") || fileJud.getPath().endsWith(".docx") ) {
				/* Wordt@C̏ꍇ̊gq WordACRݒ */
				imgI = new ImageIcon(SearchApp.iconUrl[3]);
			} else if ( fileJud.getPath().endsWith(".html") || fileJud.getPath().endsWith(".HTML") ) {
				/* Htmlt@CACRݒ */
				imgI = new ImageIcon(SearchApp.iconUrl[4]);
			} else if ( fileJud.getPath().endsWith(".ppt") || fileJud.getPath().endsWith(".pptx") ) {
				/* PowerPointt@CACRݒ */
				imgI = new ImageIcon(SearchApp.iconUrl[5]);
			} else if ( fileJud.getPath().endsWith(".pdf") || fileJud.getPath().endsWith(".PDF") ) {
				/* pdft@CACRݒ */
				imgI = new ImageIcon(SearchApp.iconUrl[6]);
			} else if (fileJud.getPath().lastIndexOf(".") == -1) {
				/* gqt@C(t@C . t@CŔf) */
				imgI = new ImageIcon(SearchApp.iconUrl[7]);
			}

		} else if ( fileJud.isHidden() ) {
			/* Bt@C̏ꍇ */
			imgI = new ImageIcon(SearchApp.iconUrl[7]);
		} else {
			/* t@CȊȌꍇ */
			imgI = new ImageIcon(SearchApp.iconUrl[7]);
		}

		/** ACR\JLabel. */
		JLabel lblIcon = new JLabel(imgI);
		lblIcon.setBorder(null);
		/* 摜\ĂJLabelR|[lg̃TCYA\ʒuw肷 */
		lblIcon.setBounds(insets.left, insets.top, imgI.getIconWidth(), imgI.getIconHeight());

		/* ACR̃}[Wݒ(ACȒ傫JTextFieldɊJĂ\) */
		this.setMargin(new Insets(insets.top, insets.left + imgI.getIconWidth() + 2, insets.bottom, insets.right));

		/* ACR\JLabelݒu */
		this.add(lblIcon);
	}

	//	public static void main(String[] args) {
	//
	//		JFrame myf = new JFrame();
	//		TextFieldHighlighter myIcon = new TextFieldHighlighter("test",false);
	//
	//		myIcon.setText("abctestabc",true);
	//
	//		myf.getContentPane().add(myIcon);
	//		myf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	//		myf.setBounds(10, 10, 400, 70);
	//		myf.setTitle("^Cg");
	//		myf.setVisible(true);
	//
	//	}

}
