/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import org.apache.poi.hwpf.HWPFDocument;
import org.apache.poi.hwpf.usermodel.Paragraph;
import org.apache.poi.hwpf.usermodel.Range;
import org.apache.poi.hwpf.usermodel.Section;
import org.apache.poi.xwpf.usermodel.XWPFDocument;
import org.apache.poi.xwpf.usermodel.XWPFFooter;
import org.apache.poi.xwpf.usermodel.XWPFHeader;
import org.apache.poi.xwpf.usermodel.XWPFParagraph;
import org.apache.poi.xwpf.usermodel.XWPFTable;


/**
 * Wordt@C(.doc .docx)ǂݍރNX.
 * @author Yuu
 * @since 2011
 */
public class WordSearch {

	InputStream inp;

	/** Word 2007ȍ~ (.docx) */
	XWPFDocument xdoc;

	/** wb_[List  (.docx)*/
	List<XWPFHeader> listH;

	/** wb_[  (.docx)*/
	XWPFHeader hed;

	/** ii{jList  (.docx)*/
	List<XWPFParagraph> listP;

	/** i({)  (.docx)*/
	XWPFParagraph para;

	/** e[u̓e  (.docx)*/ 
	List<XWPFTable> listT;

	/** e[u  (.docx)*/
	XWPFTable table;

	/** tb^[List (.docx) */
	List<XWPFFooter> listF;

	/** tb^[ */
	XWPFFooter fter;


	/** Word 2003ȑO (.doc) */
	HWPFDocument doc;

	/** Rangegp (.doc) */
	Range rang;

	/** ZNV (.doc) */
	Section sec;

	/** i (.doc) */
	Paragraph paraDoc;


	/** Wordt@C̕GREPŃqbgl(1s̒l). */
	ArrayList<String[]> wordArrList = new ArrayList<String[]>();

	/** t@CpXAt@CAZ̈ʒuA@ۑz. */
	//String kekkaStr[] = new String[5];	

	/** ʕۑf[^NX. */
	DataSearch dataSearch = new DataSearch();

	/**
	 * Wordt@C̓e擾GREPArrayListŕԂ (.docx .doc)
	 * @param wordFile     Wordt@C(.docx .doc)
	 * @param grepSearch   GrepNX
	 * @return             GrepArrayList  Stringz (t@CpXAt@CAZ̈ʒuA)
	 * @throws IOException
	 */
	public ArrayList<String[]> getWordGrep(File wordFile,GrepSearch grepSearch) throws IOException {

		/* .docxt@C Word 2007ȍ~  */
		getDocxString(wordFile,grepSearch);

		/* .doct@C Word 2007O */
		getDocString(wordFile,grepSearch);


		return wordArrList;
	}


	/**
	 * Wordt@C(.docx)ǂݍGrep܂łČʂArrayListɕۑĕԂ.
	 * @param docxFile    Wordt@C (.docx)
	 * @param grepSearch  GrepNX
	 * @return            GrepArrayList  Stringz (t@CpXAt@CAZ̈ʒuA)
	 * @throws IOException
	 */
	public ArrayList<String[]> getDocxString(File docxFile,GrepSearch grepSearch) throws IOException {

		/* .docxȊÕt@CȂ珈I */
		if ( !( docxFile.getPath().endsWith(".docx") ) ) {
			return null;
		}
		/* ʕۑXg */
		wordArrList.clear();

		ArrayList<String[]> arrTempList = new ArrayList<String[]>();

		inp = new FileInputStream(docxFile);	

		/* word 2007ȍ~ */
		xdoc = new XWPFDocument(inp);


		/* wb_[ */
		listH = xdoc.getHeaderList();

		for (int y = 0; y < listH.size(); y++) {
			hed = listH.get(y);

			/* wb_[e */
			String headLine = hed.getText();

			/* ʂz */
			//kekkaStr = getNaiyouStr(docxFile,"wb_[",headLine);
			//dataSearch.setGrepNaiyouStr(docxFile, "wb_[", headLine, "");
			/*  */
			//arrTempList.add(kekkaStr);
			arrTempList.add(dataSearch.setGrepNaiyouStr(docxFile, "wb_[", headLine, ""));

			/* GREPăqbgsԂ */
			/* GrepSearchNXɃ\bh쐬AArraylist當擾
			 * GrepăqbgsԂB */
			grepSearch.getListGrep(arrTempList,wordArrList,grepSearch);

			arrTempList.clear();

		}

		/* ii{j */
		listP = xdoc.getParagraphs();

		for (int y = 0; y < listP.size(); y++) {
			para = listP.get(y);
			/* iɂ镶 */
			String paraLine = para.getParagraphText();

			/* sԍ */
			String paraGyou = String.valueOf(y);

			/* ʂz */
			//kekkaStr = getNaiyouStr(docxFile,paraGyou,paraLine);
			//dataSearch.setGrepNaiyouStr(docxFile, paraGyou, paraLine, "");

			/*  */
			arrTempList.add(dataSearch.setGrepNaiyouStr(docxFile, paraGyou, paraLine, ""));

			/* GREPăqbgsԂ */
			/* GrepSearchNXɃ\bh쐬AArraylist當擾
			 * GrepăqbgsԂB */
			grepSearch.getListGrep(arrTempList,wordArrList,grepSearch);

			arrTempList.clear();			

		}

		/* e[u̓e */ 
		listT = xdoc.getTables();

		for (int y = 0; y < listT.size(); y++) {
			table = listT.get(y);
			/* e[uɂ镶 */
			String tableLine = table.getText();

			/* sԍ */
			String tableGyou = "e[u: " + String.valueOf(y);			

			/* ʂz */
			//kekkaStr = getNaiyouStr(docxFile,tableGyou,tableLine);
			//dataSearch.setGrepNaiyouStr(docxFile, tableGyou, tableLine, "");

			/*  */
			arrTempList.add(dataSearch.setGrepNaiyouStr(docxFile, tableGyou, tableLine, ""));

			/* GREPăqbgsԂ */
			/* GrepSearchNXɃ\bh쐬AArraylist當擾
			 * GrepăqbgsԂB */
			grepSearch.getListGrep(arrTempList,wordArrList,grepSearch);

			arrTempList.clear();	

		}

		/* tb^[ */
		listF =  xdoc.getFooterList();
		for (int y = 0; y < listF.size(); y++) {
			fter = listF.get(y);
			/* tb^[̕ */
			String fotLine = fter.getText();

			/* sԍ(iԍ) */
			String fotGyou = String.valueOf(y);			

			/* ʂz */
			//kekkaStr = getNaiyouStr(docxFile,fotGyou,fotLine);
			//dataSearch.setGrepNaiyouStr(docxFile, fotGyou, fotLine, "");

			/*  */
			arrTempList.add(dataSearch.setGrepNaiyouStr(docxFile, fotGyou, fotLine, ""));

			/* GREPăqbgsԂ */
			/* GrepSearchNXɃ\bh쐬AArraylist當擾
			 * GrepăqbgsԂB */
			grepSearch.getListGrep(arrTempList,wordArrList,grepSearch);

			arrTempList.clear();	

		}  			 	

		inp.close();

		return wordArrList;
	}


	/**
	 * Wordt@C(.doc)ǂݍGrep܂łČʂArrayListɕۑĕԂ.
	 * @param docFile     Wordt@C (.doc)
	 * @param grepSearch  GrepNX
	 * @return            GrepArrayList  Stringz (t@CpXAt@CAZ̈ʒuA)
	 * @throws IOException
	 */
	public ArrayList<String[]> getDocString(File docFile,GrepSearch grepSearch) throws IOException {

		/* .docȊÕt@CȂ珈I */
		if ( !( docFile.getPath().endsWith(".doc") ) ) {
			return null;
		}

		/* ʕۑXg */
		wordArrList.clear();

		ArrayList<String[]> arrTempList = new ArrayList<String[]>();

		inp = new FileInputStream(docFile);

		/* word 2003ȑO */
		HWPFDocument doc = new HWPFDocument(inp);

		/* Range gp */
		rang = doc.getOverallRange();

		for (int x = 0; x < rang.numSections(); x++) {
			sec = rang.getSection(x);

			for (int y = 0; y < sec.numParagraphs(); y++) {
				paraDoc = sec.getParagraph(y);

				/*  */
				String docLine = paraDoc.text();

				/* sԍ(iԍ) */
				String fotGyou = String.valueOf(y);

				/* ʂz */
				//kekkaStr = getNaiyouStr(docFile,fotGyou,docLine);
				//dataSearch.setGrepNaiyouStr(docFile, fotGyou, docLine, "");

				/*  */
				arrTempList.add(dataSearch.setGrepNaiyouStr(docFile, fotGyou, docLine, ""));

				/* GREPăqbgsԂ */
				/* GrepSearchNXɃ\bh쐬AArraylist當擾
				 * GrepăqbgsԂB */
				grepSearch.getListGrep(arrTempList,wordArrList,grepSearch);

				arrTempList.clear();

				////				for (int z = 0; z < para.numCharacterRuns(); z++) {
				////				CharacterRun run = para.getCharacterRun(z);
				////				String line = run.text();
				////				System.out.println(line);
				////				}
			}
		}

		inp.close();
		return wordArrList;
	}	


	//	/**
	//	 * e@t@CpXAt@CAZ̈ʒuA@ۑz.
	//	 * @param wordFile   t@C
	//	 * @param posi@@@ sԍ
	//	 * @param naiyouStr  e
	//	 * @return  Stringz
	//	 */
	//	public String[] getNaiyouStr(File wordFile,String posi,String naiyouStr) {
	//
	//		String kekkaStr[] = new String[5];
	//		/* t@C̃pX */
	//		kekkaStr[0] = wordFile.getAbsolutePath();						    	   
	//		/* t@C̖O */
	//		kekkaStr[1] = wordFile.getName();
	//		/* s+ */
	//		kekkaStr[2] = posi;
	//		/*  */
	//		kekkaStr[3] = naiyouStr;
	//		//System.out.println(kekkaStr[3]);
	//
	//		/*  */
	//		return kekkaStr;
	//
	//	}

}
