/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;
import java.text.NumberFormat;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.MouseInputAdapter;
import javax.swing.plaf.synth.SynthLookAndFeel;
import javax.swing.table.TableModel;
import javax.swing.tree.TreePath;

import com.ibm.icu.text.DecimalFormat;

/**
 * mainNX.
 * @author Yuu
 * @version 17.01
 * @since 2010-09
 */
public class SearchApp extends JFrame {

	private Container con;

	/** Xe[^Xo[.  */
	static JLabel taskbarLbl;

	/** Xe[^Xo[CAEgppl. */
	JPanel taskpane;

	/** GC\pvOXo[. */
	static JProgressBar taskProBarGc;

	/** j[. */
	private JMenuBar mbar;
	private JMenu filemenu,searchmenu,fontmenu,help;
	private JMenuItem openmitem,newitem,savemitem,exitmitem,searchmitem,fontmitem,helpReadMe,dellitem,option;

	/** XN[. */
	private JScrollPane myScroll,scrollTree;
	/** ʕ. */
	private JSplitPane myspane;
	/** ۑ_CAO. */
	final JFileChooser myFileChooser;

	/** ^u. */
	private JTabbedPane myTab;

	/** ^ũ^Cg. */
	private String titlestr = "";
	/** ^u^Cg. */
	public static final String GREP_TAB = "GREP";
	public static final String FILE_SEARCH_TAB = "t@CAtH_";
	public static final String NEW_TAB = "^Cg";

	protected static final Component MySearchApp = null;

	/** fBNg\. */
	private DirTree myTree;
	/** ʕ\e[u. */
	private ITableResult tableResult = new TableResult();

	/** GREP */
	public GrepTab grepTab;

	/** File */
	public FileSearchTab fileTab;

	/** G[o͗p */
	private StringBuffer errStrBuf = new StringBuffer();

	static SearchApp searApp;

	/** o[Wԍ(o[WύX̏ꍇ͂ύX). */
	private static String versionStr = "            Ver. 17.01";

	/** \tg(\tgύX̏ꍇ͂ύX). */
	private static String nameStr = "SearchApp";

	/** I. */
	public static String END_STR = "I  ";

	/** Nbv{[h. */
	static Clipboard clipboard;
	static StringSelection selection;

	/** t@CJŎgp. */
	Desktop desktop = Desktop.getDesktop();

	/** l̕\`. */
	static NumberFormat format = NumberFormat.getNumberInstance();

	/** ۑƂgp؂蕶. */
	private final String DELIMITER = "\t";

	/** sR[h擾. */
	static String crlf = System.getProperty("line.separator");

	/** t@C؂蕶擾. */
	static String SEPARATOR = System.getProperty("file.separator");

	/** ZbgAbvt@C. */
	Setup setup;

	/** [ freeMem. */
	static long freeMem;
	/** [ totalMem. */
    static long totalMem;
	/** [ maxMem. */
    static long maxMem;
	/** [ usedMem. */
    static long usedMem;
	/** [ gp䗦. */
	static double meminfoGC;

	/** ACR\邩ǂ true ACR\ false ACR\. */
	static boolean boolIcon;

	/** ACR (tH_:0 t@C:1 Excel:2 Word:3 HTML:4 PowerPoint:5 PDF:6 ̑t@C:7 SearchAppACR:8 ĂtH_:9). */
	static URL iconUrl[] = new URL[10];

	/** vpeB. */
	public ConfigDialog confDialog;

	/**
	 * @param title
	 */
	public SearchApp(String title) {
		super(title);

		/*** ACRݒ ***/
		/** tH_ACR. */
		iconUrl[0] = getClass().getResource("img/folder12.gif");

		/** t@CACR. */
		iconUrl[1] = getClass().getResource("img/file7.gif");

		/** ExcelACR. */
		iconUrl[2] = getClass().getResource("img/fileExcel2.gif");

		/** WordACR. */
		iconUrl[3] = getClass().getResource("img/fileWd.gif");

		/** HTMLt@CACR. */
		iconUrl[4] = getClass().getResource("img/fileHtml.gif");

		/** PowePointt@CACR. */
		iconUrl[5] = getClass().getResource("img/filePowerP.gif");

		/** PDFt@CACR. */
		iconUrl[6] = getClass().getResource("img/filePdf.gif");

		/** ̑̃t@CACR. */
		iconUrl[7] = getClass().getResource("img/fileOther.gif");

		/** SerachApp̃ACR. */
		iconUrl[8] = getClass().getResource("img/SearchApp.gif");

		/** ĂtH_̃ACR. */
		iconUrl[9] = getClass().getResource("img/folderClose.gif");

		/* ACR\@trueɐݒ肵Ă */
		boolIcon = true;

		for (int i = 0; i < iconUrl.length; i++) {
			/* ׂẴACRzuĂ邩mFăACRꍇ͔\falseɐݒ */
			if ( iconUrl[i] == null ) {
				/* ACRꍇ \@false*/
				boolIcon = false;
				/* for𔲂 */
				break;
			}
		}

		/** X^C   ftHg */
		try{
			//UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			//UIManager.setLookAndFeel("javax.swing.plaf.metal.MetaLookAndFeel");
			//UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");

			//			   SynthLookAndFeel synth = new SynthLookAndFeel();
			//			   synth.load(SearchApp.class.getResourceAsStream("NewFile.xml"), SearchApp.class);
			//			   UIManager.setLookAndFeel(synth);

			SwingUtilities.updateComponentTreeUI(this);
			/* ACRݒ */
			//url = this.getClass().getResource("img/SearchApp.gif");
			if ( iconUrl[8] != null ) {
				this.setIconImage(Toolkit.getDefaultToolkit().createImage(iconUrl[8]));
			} else {
				this.setIconImage(null);
			}

		} catch (Exception e) {
		}

		/** JFramẽftHg̏I葱(Ȃɐݒ) IɊmF_CAO\. */
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

		taskpane = new JPanel();
		taskpane.setLayout(new BorderLayout());

		taskbarLbl = new JLabel("   ");
		taskbarLbl.setHorizontalAlignment(SwingConstants.RIGHT);  //\E

		taskProBarGc = new JProgressBar();
		taskProBarGc.setPreferredSize(new Dimension(200, 18));
		/* JProgressBar */
		taskProBarGc.setStringPainted(true);
		taskProBarGc.setString("");
		taskProBarGc.setValue(0);

		/* URL\E */
		taskpane.add(taskProBarGc,BorderLayout.WEST);
		taskpane.add(taskbarLbl,BorderLayout.CENTER);


		/** Tab̃^CgɃ^Cgݒ. */
		titlestr = NEW_TAB;

		/** hCu[gɂJTree\. */
		myTree = new DirTree();
		scrollTree = new JScrollPane(myTree);
		scrollTree.setPreferredSize(new Dimension(130, 120));

		/** GREP */
		grepTab = new GrepTab(this);
		/** File */
		fileTab = new FileSearchTab(this);

		/** ^u. */
		myTab = new JTabbedPane();
		myTab.add(GREP_TAB,grepTab);
		myTab.add(FILE_SEARCH_TAB,fileTab);
		myScroll = new JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_NEVER,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		myScroll.getViewport().setView(myTab);

		/** ʕJSplitPane. */
		myspane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,true,scrollTree,myScroll);
		myspane.setOneTouchExpandable(true);

		/* vpeB */
		confDialog = new ConfigDialog(this);

		/** j[o[. */
		mbar = new JMenuBar();

		filemenu = new JMenu("t@C");

		savemitem = new JMenuItem("ۑ");
		dellitem = new JMenuItem("");
		exitmitem = new JMenuItem("I");

		filemenu.add(savemitem);
		filemenu.add(dellitem);
		filemenu.add(exitmitem);

		help = new JMenu("wv");
		helpReadMe = new JMenuItem("uSearchAppvɂ");
		option = new JMenuItem("vpeB");

		mbar.add(filemenu);

		mbar.add(help);
		help.add(helpReadMe);
		help.addSeparator();
		help.add(option);

		con = getContentPane();
		con.add(mbar,"North");
		con.add(myspane,"Center");
		con.add(taskpane,"South");

		myFileChooser = new JFileChooser();
		/** JgfBNg֐ݒ. */
		myFileChooser.setCurrentDirectory(new File("."));

		/** ݒt@C */
		setup = new Setup();

		/** t@Cc[\̏ꏊ }EXNbÑCxg */
		myTree.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				//int mousE = e.getButton();
				TreePath treepath = myTree.getPathForLocation(e.getX(),e.getY());
				/** pX. */
				String pathStr = "";
				if(treepath == null) {
					return;
				}
				//if(mousE == 1) {
				int c = e.getClickCount();

				//_uNbNpXݒ肵Ȃ
				if(c == 1) {

					/** NbNm[h擾 */
					File pathfile = myTree.getSubDirList(treepath);      //NbNm[h擾
					myTree.setSelectionPath(treepath);    //NbNm[hIԂ

					pathStr = pathfile.getAbsolutePath();

					int selectedTab = myTab.getSelectedIndex();
					if ( myTab.getTitleAt(selectedTab).equals(GREP_TAB) ) {
						/* GREP^u */
						/** IĂl𓾂. */
						String pathCombStr = (String) grepTab.pathCombB.getSelectedItem();
						/* t@C̃pXJComboBoxŒl͂ĂȂꍇƓlł͂ȂꍇɃNbNpXlǉ */
						if ( pathCombStr.equals("") || !pathCombStr.equals(pathStr) ) {
							grepTab.pathCombB.insertItemAt(pathStr,0);
							grepTab.pathCombB.setSelectedIndex(0);
						}
					} else  {
						/* t@C^u */
						/** IĂl𓾂. */
						String pathCombStr = (String)fileTab.pathCombB.getSelectedItem();
						/* t@C̃pXJComboBoxŒl͂ĂȂꍇƓlł͂ȂꍇɃNbNpXlǉ */
						if ( pathCombStr.equals("") || !pathCombStr.equals(pathStr) ) {
							fileTab.pathCombB.insertItemAt(pathStr,0);
							fileTab.pathCombB.setSelectedIndex(0);
						}
					}
				}
			}
		});

		/* wvj[ CZX o[W\*/
		helpReadMe.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

				/** CZX\. */
				StringBuffer LICENSETXT = new StringBuffer();
				LICENSETXT.append(nameStr);
				LICENSETXT.append(versionStr);
				LICENSETXT.append(crlf);
				LICENSETXT.append(crlf);
				LICENSETXT.append("Copyright(C) 2011 Yuu");
				LICENSETXT.append(crlf);
				LICENSETXT.append(crlf);
				LICENSETXT.append("uSearchAppv is Open Source Software released under");
				LICENSETXT.append(crlf);
				LICENSETXT.append("the GNU General Public License version 3 GPL v3.");
				LICENSETXT.append(crlf);
				LICENSETXT.append("The original author is Yuu.");
				LICENSETXT.append(crlf);
				LICENSETXT.append(crlf);
				LICENSETXT.append("gpCuAQl\[XȂǂ̃CZX");
				LICENSETXT.append(crlf);
				LICENSETXT.append("ɂĂDocumenttH_NOTICE.txtt@C  ");
				LICENSETXT.append(crlf);
				LICENSETXT.append(crlf);

				showMessageHelp(LICENSETXT.toString(),"SearchApp ɂ ");
			}
		});

		/**
		 *  vpeB.
		 */
		option.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				confDialog.setSize(480,450);
				confDialog.setLocationRelativeTo(searApp);
				SwingUtilities.updateComponentTreeUI(confDialog);
				confDialog.setVisible(true);
			}
		});

		/* eJComboBox̗̒l*/
		dellitem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* GREP^u */
				grepTab.grepFileCombB.removeAllItems();
				grepTab.grepFileCombB.addItem("");
				grepTab.pathCombB.removeAllItems();
				grepTab.pathCombB.addItem("");
				grepTab.filterCombB.removeAllItems();
				grepTab.filterCombB.addItem("");
				/* t@C@tH_^u */
				fileTab.fileCombB.removeAllItems();
				fileTab.fileCombB.addItem("");
				fileTab.pathCombB.removeAllItems();
				fileTab.pathCombB.addItem("");
			}
		});

		/** Ij[. */
		exitmitem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* I */
				endMsd();
			}
		});

		/** ʏICxg. */
		this.addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				/* I */
				endMsd();
			}
		});

		/** }EXړCxg. */
		 this.addMouseMotionListener(new MouseInputAdapter() {
			 public void mouseMoved(MouseEvent e) {
				 /* [XV */
				SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
				SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);
			   }
		 });

		/** ۑCxg. */
		savemitem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* e[u̒l */
				TableModel tableModel = null;

				JScrollPane scrollTable = null;

				/* ۑW_CAO */
				JFileChooser myFileChooser = new JFileChooser();
				int intRet = myFileChooser.showSaveDialog(SearchApp.this);

				/*yesOK{^ꂽ*/
				if (intRet == JFileChooser.APPROVE_OPTION) {

					/* I\ĂTabJTextPasne𓾂 */
					int selectedTab = myTab.getSelectedIndex();
					if ( myTab.getTitleAt(selectedTab).equals(GREP_TAB) ) {
						/* GREP^ȕꍇ */
						scrollTable =  (JScrollPane) grepTab.myTabbedPane.getSelectedComponent();
					} else {
						/* File^ȕꍇ */
						scrollTable =  (JScrollPane) fileTab.myTabbedPane.getSelectedComponent();
					}
					/* ^uɕ\Ăe[u𓾂 */
					ITableResult resultTable = (ITableResult)scrollTable.getViewport().getView();
					tableModel = resultTable.getDfTable();

					/* \Ă^ũe[uf[^t@C֒o */
					fileCreate(tableModel,myFileChooser);
				}
			}
		});

		/**
		 * ^uCxgŃXe[^Xo[̌ʂXV.
		 */
		myTab.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {

				JScrollPane scrollTable = null;

				/* I\ĂTab𓾂 */
				int selectedTab = myTab.getSelectedIndex();
				if ( myTab.getTitleAt(selectedTab).equals(GREP_TAB) ) {
					/* GREP^ȕꍇ */
					scrollTable =  (JScrollPane) grepTab.myTabbedPane.getSelectedComponent();
				} else {
					/* File^ȕꍇ */
					scrollTable =  (JScrollPane) fileTab.myTabbedPane.getSelectedComponent();
				}
				/* ^uɕ\Ăe[u𓾂 */
				ITableResult resultTable = (ITableResult)scrollTable.getViewport().getView();

				if ( resultTable.getChkFlg() ) {
					/* Xe[^Xo[Ɍʂ\ */
					taskbarLbl.setText(resultTable.getProgresBarStr() + "@@");
				}
			}
		});

		searApp = this;

		try {
			/* ݒt@C̓e𔽉f */
			setup.setSetupInfo(searApp, grepTab,fileTab);

		} catch (Exception e) {
			/* G[̏ꍇftHg̒lɐݒ肷 */
			setup.setDefaultInfo(searApp, grepTab,fileTab);
		}

		taskbarLbl.setToolTipText("<html>}EXNbNŕ\URLRs[</html>");

		/* Xe[^Xo[̃xNbNꍇ̃Cxg */
		taskbarLbl.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				/** }EXNbN */
				//f (SwingUtilities.isLeftMouseButton(e)) {
					/* Xe[^Xo[ɕ\ĂURLNbv{[hփRs[ */
					SearchApp.clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
					SearchApp.selection = new StringSelection(taskbarLbl.getText().trim());
					SearchApp.clipboard.setContents(SearchApp.selection, null);
				//}
			}
			});

		/* RXgN^I */
	}

	/**
	 *  I(ʕ\ʒu擾ĕۑ).
	 */
	public void endMsd() {
		if( !(showMyConfirm("I܂H")) ) {
			return;
		}
		try {
			/* ݂̉ʂ̑傫\ʒuݒt@C֕ۑ */
			/* ݒt@Cꍇ͍쐬 */
			setup.createSetupFile();
			/* ݂̉ʂ̑傫\ʒuݒt@C֕ۑ  eTabɓĂJComboBox̒lݒt@C֕ۑ */
			setup.getInfo(this, grepTab, fileTab);
			/* I */
			System.exit(0);
		}catch (Exception err){

		}finally{
			/* I */
			System.exit(0);
		}
	}

	/**
	 * \Ă^uʂ̃e[u̒l𒊏o(DELIMITERϐŎw).
	 * @param myTableModel    \Ă^uʂ̃e[uf[^
	 * @param myFileChooser   JFileChooser
	 */
	public void fileCreate(TableModel myTableModel,JFileChooser myFileChooser) {
		try {
			File myFile = myFileChooser.getSelectedFile();  //Iꂽt@C̎擾
			PrintWriter myWriter = new PrintWriter(new BufferedWriter(new FileWriter(myFile.getAbsolutePath())));
			Object myOb = null;
			for (int i = 0; i < myTableModel.getRowCount(); i++) {
				for (int j = 0; j < myTableModel.getColumnCount() -1; j++) {
					myOb = myTableModel.getValueAt(i,j);

					/*ϊ(NULLƂȂɂĂȂ󗓂)*/
					if (myOb == null || myOb.equals("")) {
						/*Ōɂ̓R}, tȂ*/
						if ( j != (myTableModel.getColumnCount() - 1)) {
							/* ؂蕶} */
							myWriter.print(DELIMITER);
							//System.out.print(" ,");
						} else {//Ōɂ̓R}, tȂ
							myWriter.print(" ");
							//System.out.print(" ");
						}
					} else {
						/*Ōɂ̓R}, tȂ*/
						if ( j != (myTableModel.getColumnCount() - 1)) {
							//System.out.print(myOb+" ");
							/* ؂蕶} */
							myWriter.print(myOb+DELIMITER);
						} else {//Ōɂ̓R}, tȂ
							myWriter.print(myOb);
							//System.out.print(myOb);
						}
					}
				}
				myWriter.println();
			}
			myWriter.close();
		} catch (IOException ie) {
			ie.printStackTrace();
		}
	}

	/**
	 *  Ip_CAO{bNX.
	 * @param stMess  \bZ[W
	 * @return
	 */
	boolean showMyConfirm(String stMess) {
		boolean myRet = true;
		if(JOptionPane.showConfirmDialog(this, stMess) != JOptionPane.YES_OPTION) {
			myRet = false;
		}
		return myRet;
	}

	/**
	 * _CAO{bNX@@@@CZX\L.
	 * @param stMess  @@@@{
	 * @param title@@@@@@^Cg
	 * @param messageType@bZ[W^Cv@x
	 * @param icon@@@@@@ACR
	 */
	public static void showMessageHelp(String stMess,String title) {
		JOptionPane.showMessageDialog(searApp,stMess,title,JOptionPane.INFORMATION_MESSAGE,
				new ImageIcon( new ImageIcon(iconUrl[8]).getImage().getScaledInstance(50, 50, 1) ) );
	}

	/**
	 * _CAO{bNX.
	 * @param stMess
	 */
	public static void showMessage(String stMess) {
		JOptionPane.showMessageDialog(searApp,stMess);
	}

	/**
	 * JTextAreã_CAO{bNX\.
	 * @param parent             ẽt[
	 * @param stbTxt             G[eeLXg
	 * @param title                ^Cg
	 * @param messageType  bZ[W̃^Cv   ERROR_MESSAGEAINFORMATION_MESSAGEAWARNING_MESSAGEAQUESTION_MESSAGEAPLAIN_MESSAGE
	 */
	public static void showTextMessage(JFrame parent,StringBuffer stbTxt,String title,int messageType) {
		final JTextArea txtArea = new JTextArea();
		txtArea.setEditable(false);
		txtArea.setText(stbTxt.toString());
		txtArea.setCaretPosition(0);
		JScrollPane scrollPane = new JScrollPane(txtArea);
		scrollPane.setPreferredSize(new Dimension(400, 320));
		//JOptionPane.showMessageDialog(parent,scrollPane,title,messageType);

		/*******}EXENbÑ|bvAbvj[**********************/
		/** ENbNp̃|bvAbvj[. */
		final JPopupMenu mouseMenu;
		/** Rs[j[. */
		final JMenuItem copyItem;
		/** ׂđIj[. */
		JMenuItem  sentakuItem;
		/** \tj[. */
		JMenuItem  haritukeItem;
		mouseMenu = new JPopupMenu();
		sentakuItem = new JMenuItem("ׂđI");
		copyItem = new JMenuItem("Rs[");
		mouseMenu.add(sentakuItem);
		mouseMenu.addSeparator();
		mouseMenu.add(copyItem);
		/* eLXgGAɃ|bvAbvj[\ */
		txtArea.setComponentPopupMenu(mouseMenu);

		/* ENbN@Nbv{[hփRs[ */
		copyItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* IĂ镶𓾂. */
				String str = txtArea.getSelectedText();
				/* Nbv{[hփpXRs[ */
				clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				selection = new StringSelection(str);
				clipboard.setContents(selection, null);
			}
		});

		/* ׂđI */
		sentakuItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				txtArea.requestFocusInWindow();
				/* ׂđI. */
				txtArea.selectAll();
			}
		});
		/*******}EXENbÑ|bvAbvj[@܂**********************/

		/* bZ[W_CAO\ */
		JOptionPane.showMessageDialog(parent,scrollPane,title,messageType);
	}

	/**
	 * ^u(GREPAFile)Ōʂ\e[ũ^u쐬.
	 * @param tabName               ^uɕ\閼O
	 * @param resultGrepTable     e[uNX
	 * @param scrollTable             XN[NX
	 * @param myTabbedPane      ^uNX
	 * @param tabN                     Grep^u  t@C^u
	 */
	public void creatTab(String tabName,ITableResult resultGrepTable,JScrollPane scrollTable,MyJTabbedPaneS myTabbedPane,String tabN) {
		/*
		 * e[u^uꍇ͐V
		 * \Ăe[ugpĂꍇ͐V^u
		 * gp̏ꍇ͂̃e[uɏށ@@@@@@@@@@@@@@  */
		if ( resultGrepTable == null || myTabbedPane.getTabCount()<= 0 || resultGrepTable.getChkFlg() ) {

			/* GREP^uʂ̏ꍇ */
			if (tabN.equals(GrepTab.GREP_TAB)) {
				this.grepTab.resultGrepTable = new TableResult();
				resultGrepTable = this.grepTab.resultGrepTable;
				/* GREPZbgiZ̋\̂߁j */
				resultGrepTable.setSearchStr(grepTab.grepFileCombB.getSelectedItem().toString());
				/* GREP啶̒lZbg iZ̋\̂߁j */
				resultGrepTable.setMojiBool(GrepTab.mojiCheck.isSelected());
			} else {
				/* File^uʂ̏ꍇ */
				this.fileTab.resultTable = new TableResultFile();
				resultGrepTable = this.fileTab.resultTable;
				/* FileZbgiZ̋\̂߁j */
				resultGrepTable.setSearchStr(fileTab.fileCombB.getSelectedItem().toString());
				/* File啶̒lZbg iZ̋\̂߁j */
				resultGrepTable.setMojiBool(FileSearchTab.mojiCheck.isSelected());
			}

			scrollTable = new JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
					JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			scrollTable.getViewport().setView((Component) resultGrepTable);
			scrollTable.setPreferredSize(new Dimension(300,250));

			/** ʃeLXgzu^u. */
			myTabbedPane.add(tabName,scrollTable);
			/* tH[JXړ */
			myTabbedPane.setSelectedComponent(scrollTable);
			/*@gpς݂֕ύX@*/
			resultGrepTable.setChkFlg(true);

		} else {
			/*@gpς݂֕ύX@*/
			resultGrepTable.setChkFlg(true);

			if (tabN.equals(GrepTab.GREP_TAB)) {
				/* GREPZbgiZ̋\̂߁j */
				resultGrepTable.setSearchStr(grepTab.grepFileCombB.getSelectedItem().toString());
				/* GREP啶̒lZbg iZ̋\̂߁j */
				resultGrepTable.setMojiBool(GrepTab.mojiCheck.isSelected());
			} else {
				/* FileZbgiZ̋\̂߁j */
				resultGrepTable.setSearchStr(fileTab.fileCombB.getSelectedItem().toString());
				/* File啶̒lZbg iZ̋\̂߁j */
				resultGrepTable.setMojiBool(FileSearchTab.mojiCheck.isSelected());
			}
			/* ^u̖OύX */
			myTabbedPane.setTabListTitle(0,tabName);
		}
	}

	/**
	 * GREP^u.
	 * @return
	 */
	public GrepTab getGrepTab() {
		return this.grepTab;
	}

	/**
	 *  JSplitPaneʕ̃TCY.
	 * @return
	 */
	public JSplitPane getJSplitpane() {
		return this.myspane;
	}

	/**
	 * JavãeʁAgp
	 * @return 
	 */
	public static String getMemInfo() {

	    String memStr;

	    freeMem = Runtime.getRuntime().freeMemory() / 1048576;
	    totalMem = Runtime.getRuntime().totalMemory() / 1048576;
	    maxMem = Runtime.getRuntime().maxMemory() / 1048576;
	    usedMem = totalMem - freeMem;
	    meminfoGC = (usedMem * 100 / (double)totalMem);

	    memStr = " : " + totalMem + " MB  " + usedMem + " MB " + (int)Math.floor(meminfoGC) + "%" ;

	    return memStr;
	}


	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				SearchApp  seaapp = new SearchApp("t@C");
				/* ^Cgƃo[W */
				seaapp.setTitle(nameStr+ versionStr );
				//seaapp.setSize(450,400);
				seaapp.pack();
				seaapp.setVisible(true);
				 /* [XV */
				SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
				SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);
			}
		});
		}

}
